(princ "\nLade IGM Tools...")
(load"igmtools.ini")
(load"igmlib")

;******************************************************************
;igm_acad.lsp

(defun c:igm ()
 (setvar "cmdecho" 0)
 (command "_.menuunload" "igm")
 (command "_.menuload" "igm.mnu")
 (menucmd "P2=+IGM.POP1")
 (igmlib)
 (princ)
)

(defun myerror (s)                    ; If an error (such as CTRL-C) occurs
  (if (/= s "Function cancelled")
    (princ (strcat "\nError: " s))
    (redraw)
  )
  (if olderr (setq *error* olderr))  ; Restore old *error* handler
  (redraw)
 (princ) 
)


(defun igm_einfuege (datei / )
 (command "_.insert" datei)
 (princ)
)

(defun igm_einfuege_1-1 (datei / )
 (command "_.insert" datei pause 1 1 0)
 (princ)
)

(defun igm_kopf_einfuege_1-1 (datei / )
 (command "_.insert" datei "_end" pause 1 1 0)
 (princ)
)


(defun igm_alt_format_einfuege (datei / )
 (setvar "attreq" 0)
 (setvar "attdia" 0)
 (setq tilemode_old (getvar "tilemode"))
 (if (= tilemode_old 1)
     (progn
      (alert "Zeichnungsrahmen drfen nur im Papierbereich eingefgt werden!")
      (setvar "tilemode" 0)
     )
 )
 (setvar "clayer" "0")
 (command "_.insert" datei "0,0" 1 1 0)
 (command"_.zoom" "_e")
 (command"_.zoom" "0.95x")
 (setvar "attreq" 1)
 (setvar "attdia" 1)
 (princ)
)

(defun igm_neu_config ( / antw)
 (alert"Alle Drucker und Plotter werden gelscht.")
 (setq antw "n")
 (initget "j n")
 (setq antw (getkword "\nSind Sie sicher <n>/j :"))
 (if (= antw "j")
     (progn
      (setq acad14_cfg (strcat "copy " igm_server_lisp_path "acad14.cfg C:\\r14"))
      (command "sh" acad14_cfg)
      (alert"Damit die nderung wirksam wird, mu AutoCAD gestartet werden.")
     )
     (alert"Es wurde nichts verndert")
 )
 (princ)
)

 (setvar "cmdecho" 0)
 (setvar "cmddia" 1)
 (setvar "filedia" 1)
(princ)


;******************************************************************

(defun c:twskal (/ ae ao e_list aon aen textstil_alte_dwg zw_faktor zw_neu a b)

 (setq textstil_alte_dwg "standard") 
 (setq zw_faktor (getreal "\nZeichenweitenskalierung : "))

 (if (tblsearch "STYLE" "ISO8")
     (progn
      (command "_.rename" "_s" "ISO8" "GENISO")
      (command "_.style" "geniso" "geniso.shx" "0" "1" "0" "n" "n")
     )
 )


 (setq a (tblnext "BLOCK" T))
 (setq ae (cdr (assoc -2 a)))
 (setq ao (cdr (assoc 0 a)))
 (while
  (setq aen (entnext ae))
  (setq aon (cdr (assoc 0 (entget aen))))

  (if (= aon "TEXT")
   (progn
    (setq e_list (entget aen))
    (setq zw_alt (cdr (assoc 41 e_list)))
    (setq zw_neu (* zw_alt zw_faktor))
    (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
    (entmod e_list)
    (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
    (entmod e_list)
    (entupd (cdr (assoc -1 e_list)))
   ) 
  )

  (if (= aon "ATTDEF")
   (progn
    (setq e_list (entget aen))
    (setq zw_alt (cdr (assoc 41 e_list)))
    (setq zw_neu (* zw_alt zw_faktor))
    (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
    (entmod e_list)
    (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
    (entmod e_list)
    (entupd (cdr (assoc -1 e_list)))
   ) 
  )

  (setq ae aen)
 )
 (while
  (setq a (tblnext "BLOCK"))
  (setq ae (cdr (assoc -2 a)))
  (while
   (setq aen (entnext ae))
   (setq aon (cdr (assoc 0 (entget aen))))

   (if (= aon "TEXT")
    (progn
     (setq e_list (entget aen))
     (setq zw_alt (cdr (assoc 41 e_list)))
     (setq zw_neu (* zw_alt zw_faktor))
     (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list)
     (entupd (cdr (assoc -1 e_list)))
    ) 
   )

   (if (= aon "ATTDEF")
    (progn
     (setq e_list (entget aen))
     (setq zw_alt (cdr (assoc 41 e_list)))
     (setq zw_neu (* zw_alt zw_faktor))
     (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list)
     (entupd (cdr (assoc -1 e_list)))
    ) 
   )

   (setq ae aen)
  )
 )
 (func_twskal zw_faktor)
 (func_twattskal zw_faktor)
 (command "_.regen")
 (princ)
)


(defun func_twskal (zw_faktor / )
 (setq a (entnext))
 (if (or (= (cdr (assoc 0 (entget a))) "TEXT")(= (cdr (assoc 0 (entget a))) "ATTDEF"))
  (progn
   (setq e_list (entget a))
   (setq zw_alt (cdr (assoc 41 e_list)))
   (setq zw_neu (* zw_alt zw_faktor))
   (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
   (entmod e_list)
   (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
   (entmod e_list)
  ) 
 )

  (while
   (setq b (entnext a))
   (if (or (= (cdr (assoc 0 (entget b))) "TEXT")(= (cdr (assoc 0 (entget b))) "ATTDEF"))
    (progn
     (setq e_list (entget b))
     (setq zw_alt (cdr (assoc 41 e_list)))
     (setq zw_neu (* zw_alt zw_faktor))
     (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list) 
    ) 
   )

  (setq a b)
  )
 (princ)
)

(defun func_twattskal (zw_faktor / )
 (setq a (entnext))
 (if (= (cdr (assoc 0 (entget a))) "INSERT")
  (progn
   (while 
    (setq an (entnext (cdr (assoc -1 (entget a)))))
    (if (= (cdr (assoc 0 (entget an))) "ATTRIB")
        (progn
         (setq e_list (entget an))
         (setq zw_alt (cdr (assoc 41 e_list)))
         (setq zw_neu (* zw_alt zw_faktor))
         (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
         (entmod e_list)
         (entupd (cdr (assoc -1 e_list)))
        )
    ) 
    (setq a an)    
   )
  ) 
 )

  (while
   (setq b (entnext a))

 (if (= (cdr (assoc 0 (entget b))) "INSERT")
  (progn
   (while 
    (setq bn (entnext (cdr (assoc -1 (entget b)))))
    (if (= (cdr (assoc 0 (entget bn))) "ATTRIB")
        (progn
         (setq e_list (entget bn))
         (setq zw_alt (cdr (assoc 41 e_list)))
         (setq zw_neu (* zw_alt zw_faktor))
         (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
         (entmod e_list)
         (entupd (cdr (assoc -1 e_list)))
        )
    ) 
    (setq b bn)    
   )
  ) 
 )
  (setq a b)
  )
 (princ)
)

(princ)

;***************************

(defun c:twfix (/ ae ao e_list aon aen textstil_alte_dwg zw_faktor a b)
 (setq textstil_alte_dwg "standard") 
 (setq zw_faktor (getreal "\nZeichenweitenfaktor : "))

 (if (tblsearch "STYLE" "ISO8")
     (progn
      (command "_.rename" "_s" "ISO8" "GENISO")
      (command "_.style" "geniso" "geniso.shx" "0" "1" "0" "n" "n")
     )
 )

 (setq a (tblnext "BLOCK" T))
 (setq ae (cdr (assoc -2 a)))
 (setq ao (cdr (assoc 0 a)))
 (while
  (setq aen (entnext ae))
  (setq aon (cdr (assoc 0 (entget aen))))

  (if (= aon "TEXT")
   (progn
    (setq e_list (entget aen))
    (setq e_list (subst (cons 41 zw_faktor) (assoc 41 e_list) e_list))
    (entmod e_list)
    (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
    (entmod e_list)
    (entupd (cdr (assoc -1 e_list)))
   ) 
  )

  (if (= aon "ATTDEF")
   (progn
    (setq e_list (entget aen))
    (setq e_list (subst (cons 41 zw_faktor) (assoc 41 e_list) e_list))
    (entmod e_list)
    (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
    (entmod e_list)
    (entupd (cdr (assoc -1 e_list)))
   ) 
  )

  (setq ae aen)
 )
 (while
  (setq a (tblnext "BLOCK"))
  (setq ae (cdr (assoc -2 a)))
  (while
   (setq aen (entnext ae))
   (setq aon (cdr (assoc 0 (entget aen))))

   (if (= aon "TEXT")
    (progn
     (setq e_list (entget aen))
     (setq e_list (subst (cons 41 zw_faktor) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list)
     (entupd (cdr (assoc -1 e_list)))
    ) 
   )

   (if (= aon "ATTDEF")
    (progn
     (setq e_list (entget aen))
     (setq e_list (subst (cons 41 zw_faktor) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list)
     (entupd (cdr (assoc -1 e_list)))
    ) 
   )

   (setq ae aen)
  )
 )
 (func_twfix zw_faktor)
 (func_twattfix zw_faktor)
 (command "_.regen")
 (princ)
)


(defun func_twfix (zw_faktor / )
 (setq a (entnext))
 (if (or (= (cdr (assoc 0 (entget a))) "TEXT")(= (cdr (assoc 0 (entget a))) "ATTDEF"))
  (progn
   (setq e_list (entget a))
   (setq e_list (subst (cons 41 zw_faktor) (assoc 41 e_list) e_list))
   (entmod e_list)
   (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
   (entmod e_list)
  ) 
 )

  (while
   (setq b (entnext a))
   (if (or (= (cdr (assoc 0 (entget b))) "TEXT")(= (cdr (assoc 0 (entget b))) "ATTDEF"))
    (progn
     (setq e_list (entget b))
     (setq e_list (subst (cons 41 zw_faktor) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list)
    ) 
   )

  (setq a b)
  )
 (princ)
)

(defun func_twattfix (zw_faktor / )
 (setq a (entnext))
 (if (= (cdr (assoc 0 (entget a))) "INSERT")
  (progn
   (while 
    (setq an (entnext (cdr (assoc -1 (entget a)))))
    (if (= (cdr (assoc 0 (entget an))) "ATTRIB")
        (progn
         (setq e_list (entget an))
         (setq e_list (subst (cons 41 zw_faktor) (assoc 41 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
         (entmod e_list)
         (entupd (cdr (assoc -1 e_list)))
        )
    ) 
    (setq a an)    
   )
  ) 
 )

  (while
   (setq b (entnext a))

 (if (= (cdr (assoc 0 (entget b))) "INSERT")
  (progn
   (while 
    (setq bn (entnext (cdr (assoc -1 (entget b)))))
    (if (= (cdr (assoc 0 (entget bn))) "ATTRIB")
        (progn
         (setq e_list (entget bn))
         (setq e_list (subst (cons 41 zw_faktor) (assoc 41 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
         (entmod e_list)
         (entupd (cdr (assoc -1 e_list)))
        )
    ) 
    (setq b bn)    
   )
  ) 
 )
  (setq a b)
  )
 (princ)
)

(princ)

;***************************

(defun twattskal_MB ( zw_faktor / ae ao e_list aon aen textstil_alte_dwg zw_faktor a b)

 (setq textstil_alte_dwg "standard") 

 (if (tblsearch "STYLE" "ISO8")
     (progn
      (command "_.rename" "_s" "ISO8" "GENISO")
      (command "_.style" "geniso" "geniso.shx" "0" "1" "0" "n" "n")
     )
 )


 (setq a (tblnext "BLOCK" T))
 (setq ae (cdr (assoc -2 a)))
 (setq ao (cdr (assoc 0 a)))
 (while
  (setq aen (entnext ae))
  (setq aon (cdr (assoc 0 (entget aen))))

  (if (= aon "ATTDEF")
   (progn
    (setq e_list (entget aen))
    (setq zw_alt (cdr (assoc 41 e_list)))
    (setq zw_neu (* zw_alt zw_faktor))
    (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
    (entmod e_list)
    (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
    (entmod e_list)
    (setq e_list (subst (cons 8 "RAHM5") (assoc 8 e_list) e_list))
    (entmod e_list)
    (entupd (cdr (assoc -1 e_list)))
   ) 
  )

  (setq ae aen)
 )
 (while
  (setq a (tblnext "BLOCK"))
  (setq ae (cdr (assoc -2 a)))
  (while
   (setq aen (entnext ae))
   (setq aon (cdr (assoc 0 (entget aen))))


   (if (= aon "ATTDEF")
    (progn
     (setq e_list (entget aen))
     (setq zw_alt (cdr (assoc 41 e_list)))
     (setq zw_neu (* zw_alt zw_faktor))
     (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 8 "RAHM5") (assoc 8 e_list) e_list))
     (entmod e_list)
     (entupd (cdr (assoc -1 e_list)))
    ) 
   )

   (setq ae aen)
  )
 )
 (func_twattribskal_1 zw_faktor)
 (func_twattribskal_2 zw_faktor)
 (command "_.regen")
 (princ)
)


(defun func_twattribskal_1 (zw_faktor / )
 (setq a (entnext))
 (if (= (cdr (assoc 0 (entget a))) "ATTDEF")
  (progn
   (setq e_list (entget a))
   (setq zw_alt (cdr (assoc 41 e_list)))
   (setq zw_neu (* zw_alt zw_faktor))
   (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
   (entmod e_list)
   (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
   (entmod e_list)
   (setq e_list (subst (cons 8 "RAHM5") (assoc 8 e_list) e_list))
   (entmod e_list)
  ) 
 )

  (while
   (setq b (entnext a))
   (if (= (cdr (assoc 0 (entget b))) "ATTDEF")
    (progn
     (setq e_list (entget b))
     (setq zw_alt (cdr (assoc 41 e_list)))
     (setq zw_neu (* zw_alt zw_faktor))
     (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list) 
     (setq e_list (subst (cons 8 "RAHM5") (assoc 8 e_list) e_list))
     (entmod e_list)
    ) 
   )

  (setq a b)
  )
 (princ)
)

(defun func_twattribskal_2 (zw_faktor / )
 (setq a (entnext))
 (if (= (cdr (assoc 0 (entget a))) "INSERT")
  (progn
   (while 
    (setq an (entnext (cdr (assoc -1 (entget a)))))
    (if (= (cdr (assoc 0 (entget an))) "ATTRIB")
        (progn
         (setq e_list (entget an))
         (setq zw_alt (cdr (assoc 41 e_list)))
         (setq zw_neu (* zw_alt zw_faktor))
         (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 8 "RAHM5") (assoc 8 e_list) e_list))
         (entmod e_list)
         (entupd (cdr (assoc -1 e_list)))
        )
    ) 
    (setq a an)    
   )
  ) 
 )

  (while
   (setq b (entnext a))

 (if (= (cdr (assoc 0 (entget b))) "INSERT")
  (progn
   (while 
    (setq bn (entnext (cdr (assoc -1 (entget b)))))
    (if (= (cdr (assoc 0 (entget bn))) "ATTRIB")
        (progn
         (setq e_list (entget bn))
         (setq zw_alt (cdr (assoc 41 e_list)))
         (setq zw_neu (* zw_alt zw_faktor))
         (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 8 "RAHM5") (assoc 8 e_list) e_list))
         (entmod e_list)
         (entupd (cdr (assoc -1 e_list)))
        )
    ) 
    (setq b bn)    
   )
  ) 
 )
  (setq a b)
  )
 (princ)
)

(princ)


;************************

(defun c:twattskal ( / ae ao e_list aon aen textstil_alte_dwg zw_faktor a b)

 (setq textstil_alte_dwg "standard") 
 (setq zw_faktor (getreal "\nZeichenweitenskalierung : "))

 (if (tblsearch "STYLE" "ISO8")
     (progn
      (command "_.rename" "_s" "ISO8" "GENISO")
      (command "_.style" "geniso" "geniso.shx" "0" "1" "0" "n" "n")
     )
 )


 (setq a (tblnext "BLOCK" T))
 (setq ae (cdr (assoc -2 a)))
 (setq ao (cdr (assoc 0 a)))
 (while
  (setq aen (entnext ae))
  (setq aon (cdr (assoc 0 (entget aen))))

  (if (= aon "ATTDEF")
   (progn
    (setq e_list (entget aen))
    (setq zw_alt (cdr (assoc 41 e_list)))
    (setq zw_neu (* zw_alt zw_faktor))
    (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
    (entmod e_list)
    (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
    (entmod e_list)
    (entupd (cdr (assoc -1 e_list)))
   ) 
  )

  (setq ae aen)
 )
 (while
  (setq a (tblnext "BLOCK"))
  (setq ae (cdr (assoc -2 a)))
  (while
   (setq aen (entnext ae))
   (setq aon (cdr (assoc 0 (entget aen))))


   (if (= aon "ATTDEF")
    (progn
     (setq e_list (entget aen))
     (setq zw_alt (cdr (assoc 41 e_list)))
     (setq zw_neu (* zw_alt zw_faktor))
     (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list)
     (entupd (cdr (assoc -1 e_list)))
    ) 
   )

   (setq ae aen)
  )
 )
 (func_twattribskal_1 zw_faktor)
 (func_twattribskal_2 zw_faktor)
 (command "_.regen")
 (princ)
)


(defun func_twattribskal_1 (zw_faktor / )
 (setq a (entnext))
 (if (= (cdr (assoc 0 (entget a))) "ATTDEF")
  (progn
   (setq e_list (entget a))
   (setq zw_alt (cdr (assoc 41 e_list)))
   (setq zw_neu (* zw_alt zw_faktor))
   (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
   (entmod e_list)
   (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
   (entmod e_list)
  ) 
 )

  (while
   (setq b (entnext a))
   (if (= (cdr (assoc 0 (entget b))) "ATTDEF")
    (progn
     (setq e_list (entget b))
     (setq zw_alt (cdr (assoc 41 e_list)))
     (setq zw_neu (* zw_alt zw_faktor))
     (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
     (entmod e_list)
     (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
     (entmod e_list) 
    ) 
   )

  (setq a b)
  )
 (princ)
)

(defun func_twattribskal_2 (zw_faktor / )
 (setq a (entnext))
 (if (= (cdr (assoc 0 (entget a))) "INSERT")
  (progn
   (while 
    (setq an (entnext (cdr (assoc -1 (entget a)))))
    (if (= (cdr (assoc 0 (entget an))) "ATTRIB")
        (progn
         (setq e_list (entget an))
         (setq zw_alt (cdr (assoc 41 e_list)))
         (setq zw_neu (* zw_alt zw_faktor))
         (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
         (entmod e_list)
         (entupd (cdr (assoc -1 e_list)))
        )
    ) 
    (setq a an)    
   )
  ) 
 )

  (while
   (setq b (entnext a))

 (if (= (cdr (assoc 0 (entget b))) "INSERT")
  (progn
   (while 
    (setq bn (entnext (cdr (assoc -1 (entget b)))))
    (if (= (cdr (assoc 0 (entget bn))) "ATTRIB")
        (progn
         (setq e_list (entget bn))
         (setq zw_alt (cdr (assoc 41 e_list)))
         (setq zw_neu (* zw_alt zw_faktor))
         (setq e_list (subst (cons 41 zw_neu) (assoc 41 e_list) e_list))
         (entmod e_list)
         (setq e_list (subst (cons 7 textstil_alte_dwg) (assoc 7 e_list) e_list))
         (entmod e_list)
         (entupd (cdr (assoc -1 e_list)))
        )
    ) 
    (setq b bn)    
   )
  ) 
 )
  (setq a b)
  )
 (princ)
)

(princ)


;***************************
(defun c:Protokol_mass ( / element efp efw box box_lu box_ro _box_a box_d p1 p2 p3 p4 delta_efw box_lay)
 (setq osmode_old (getvar "OSMODE"))
 (setq clayer_old (getvar "CLAYER"))
 (setvar "osmode" 0)
 (while (not element)
  (setq element (nentsel))
 ) 
 (setq el_list (entget (car element)))
 (setq efp (cdr (assoc 10 el_list)))
 (setq efw (cdr (assoc 50 el_list)))
 (setq box_lay (cdr (assoc 8 el_list)))
 (setvar "clayer" box_lay)
 (setq box (textbox (list (assoc 1 el_list))))
 (setq box_lu (nth 0 box))
 (setq box_ro (nth 1 box))
 (setq box_d (* (distance box_lu box_ro) 1.0))
 (setq box_a (+ efw (* (angle box_lu box_ro) 1.5)))
 (setq p1 (polar efp box_a (/ box_d 2)))
 (setq p3 box_lu)
 (setq delta_efw (- (angle efp p1) efw))
 (setq p2 (polar efp (- (+ efw pi) delta_efw)(distance efp p1)))
 (setq p3 (polar efp (+ pi box_a) (/ box_d 2)))
 (setq p4 (polar efp (- efw delta_efw)(distance efp p1)))
 (command "_.pline" p1 p2 "_a" p3 "_l" p4 "_a" p1 "")
 (command "_.change" "_l" "" "_p" "_co" "3" "")
 (setvar "clayer" clayer_old)
 (setvar "osmode" osmode_old)
 (princ)
)


(defun c:Protokol_mass_p ( / element efp efw el_list p1 p2 p3 p4 delta_efw box_lay)
 (setq osmode_old (getvar "OSMODE"))
 (setq clayer_old (getvar "CLAYER"))
 (setvar "osmode" 0)
 (while (not element)
  (setq element (nentsel))
 ) 
 (setq el_list (entget (car element)))
 (setq efp (nth 1 element))
 (setq efw (cdr (assoc 50 el_list)))
 (setq box_lay (cdr (assoc 8 el_list)))
 (setvar "clayer" box_lay)
 (setq p1 (getpoint efp "\nDiogonaler Eckpunkt"))
 (setq delta_efw (- (angle efp p1) efw))
 (setq p2 (polar efp (- (+ efw pi) delta_efw)(distance efp p1)))
 (setq p3 (polar efp (+ efw pi delta_efw) (* 1 (distance efp p1))))
 (setq p4 (polar efp (- efw delta_efw)(distance efp p1)))
 (command "_.pline" p1 p2 "_a" p3 "_l" p4 "_a" p1 "")
 (command "_.change" "_l" "" "_p" "_co" "3" "")
 (setvar "clayer" clayer_old)
 (setvar "osmode" osmode_old)
 (princ)
)


;*************************

(defun c:alt_rahm_pbreich ( / mstb auswahl antw alter_rahmen)
 (setq *error* myerror)
 (if (= (getvar "tilemode") 0)
     (alert "Funktion im Papierbereich nicht zulssig!")
     (func_alt_rahm_pbreich)
 )
 (setq *error* olderr)
 (princ)
)

(defun c:objekte_pbreich ( / mstb auswahl antw alter_rahmen)
 (setq *error* myerror)
 (if (= (getvar "tilemode") 0)
     (alert "Funktion im Papierbereich nicht zulssig!")
     (func_objekte_pbreich)
 )
 (setq *error* olderr)
 (princ)
)



(defun func_alt_rahm_pbreich ()
 (setvar "cmdecho" 1)
 (setvar "clayer" "0")
 (setvar "attreq" 0)
 (command "_.zoom" "_e")
 (command "_.zoom" "0.95x")
 (while (/= antw "j")
  (initget 7)
  (setq mstb (getreal "\nMastab (z.B. 25 -> 1:25  oder  0.2 -> 5:1) : "))
  (setq auswahl (ssget))
  (initget " j n")
  (setq antw (getkword "\nEingaben korrekt <j>/n : "))
  (if (= antw nil)(setq antw "j"))
 )       
 (command "_.cutclip" auswahl "")
 (command "_.tilemode" 0)
 (command "_.pasteclip" "0,0" (/ 1 mstb) (/ 1 mstb) "0")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.95x")
 (setq alter_rahmen (cdr (assoc 2 (entget (entlast)))))
 (command "_.explode" "_l")
 (command "_.purge" "_bl" alter_rahmen "_n")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.95x")
 (if (not (tblsearch "LAYER" "VIEW"))
     (command "_.-layer" "_m" "view" "_co" "1" "view" "")
 )
 (command "_.mview" (getvar "extmin")(getvar "extmax")) 
 (setvar "clayer" "0")
 (command "_.limits" (getvar "extmin")(getvar "extmax"))
 (command "_.-layer" "_f" "view" "")
 (setq af_mstb (strcat (rtos (/ 1 mstb) 2 4) "XP"))
 (command "_.mspace")
 (command "_.zoom" af_mstb)
 (command "_.pspace")
 (setvar "attreq" 1)
)


(defun func_objekte_pbreich ()
 (setvar "cmdecho" 1)
 (setvar "clayer" "0")
 (setvar "attreq" 0)
 (command "_.zoom" "_e")
 (command "_.zoom" "0.95x")
 (while (/= antw "j")
  (initget 7)
  (setq mstb (getreal "\nMastab (z.B. 25 -> 1:25  oder  0.2 -> 5:1) : "))
  (setq auswahl (ssget))
  (initget " j n")
  (setq antw (getkword "\nEingaben korrekt <j>/n : "))
  (if (= antw nil)(setq antw "j"))
 )       
 (command "_.cutclip" auswahl "")
 (command "_.tilemode" 0)
 (command "_.pasteclip" "0,0" (/ 1 mstb) (/ 1 mstb) "0")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.95x")
 (setq alter_rahmen (cdr (assoc 2 (entget (entlast)))))
 (command "_.move" "_l" "" "0,0" pause)
 (command "_.explode" "_l")
 (command "_.purge" "_bl" alter_rahmen "_n")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.95x")
 (setvar "attreq" 1)
)


;*******************************

(defun c:pfeil ( / wi_pfeil ep_pfeil sp_pfeil sp1 sp2 tep)

 (setq *error* myerror)

 (setvar "cmdecho" 0)
 (init)
 (gen_layer_only_def)

 (if (not (tblsearch "LAYER" gen_2a_lay))
     (command "_.-layer" "_m" gen_2a_lay "_l" gen_2a_ltype gen_2a_lay "_c" gen_2a_farbe gen_2a_lay "")
 )

 (setq orthomode_old (getvar "orthomode"))
 (setvar "orthomode" 1)
 (setvar "osmode" 512)
 (initget 49)
 (setq SP_pfeil (getpoint "\nVon Punkt _nea to "))
 (setvar "osmode" 0)
 (initget 49)
 (setq wi_pfeil (getorient SP_pfeil "\nRichtung : "))

 (setq EP_pfeil (polar SP_pfeil       wi_pfeil (* 20 1)))
 (setq sp1      (polar SP_pfeil (- wi_pfeil (* 10 (/ pi 180))) (*  1 7))) 
 (setq sp2      (polar SP_pfeil (+ wi_pfeil (* 10 (/ pi 180))) (*  1 7))) 

 (setvar "clayer" gen_2a_lay)
 (command "_.line" SP_pfeil EP_pfeil "") 
 (command "_.change" "_l" "" "_p" "_lt" "continuous" "")
 (setq aw (ssget "_l"))
 (command "_.solid" SP_pfeil sp1 sp2 "" "")
 (setq le (entlast))
 (setq aw (ssadd le aw))
 (setq bu_pfeil (getstring "\nAnsichtsbezeichnung : " T))
 (command "_.ortho" "_off")
 (initget 1)
 (setq tep (getpoint ep_pfeil "\nNeuer Texteinfgepunkt: "))
 (command "_.text" "_j" "_m" tep (*  1 7) "0" bu_pfeil )
 (setq le (entlast))
 (setq aw (ssadd le aw))
 (command "_.-group" "_c" "*" "" aw "") 
;(command "_.change" "_l" "" "_p" "_lt" iLINIE_VOLL_50 "")
;(abschluss)
 (setvar "orthomode" orthomode_old)

 (setq *error* olderr)
(princ)
)

(defun c:aenderungsbuchstabe ()
 (setq *error* myerror)

 (setq osmode_old (getvar "osmode"))
 (setq clayer_old (getvar "clayer"))

 (setvar "cmdecho" 0)
 (setvar "osmode" 0)

 (init)
 (gen_layer_only_def)

 (if (not (tblsearch "LAYER" gen_6_lay))
     (command "_.-layer" "_m" gen_6_lay "_c" gen_6_farbe gen_6_lay "")
 )

 (initget 49)
 (setq efp (getpoint "\nEinfgepunkt: "))
 (setvar "osmode" osmode_old)
 (setq aenderungsindex (getstring "\nnderungsindex: "))
 (setvar "clayer" gen_6_lay)
 (command "_.text" "_j" "_mc" efp 3.5 0 aenderungsindex)
 (command "_.circle" efp (* 3.5 0.75))
 (command "_.change" "_l" "" "_p" "_co" 3 "")
 (setvar "clayer" clayer_old)
 (setvar "osmode" osmode_old)

 (setq *error* olderr)
(princ)
)




;***********************************


(defun igm_alt_druck ( pc2-file / )
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
      (command "_.plot" "_l" "5" "_y" IGM_DRUCKER "_l" "2" PC2-file "_l"  "0")
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)

(defun igm_alt_plot ( pc2-file / )
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
      (if (= (getvar "tilemode") 1)
          (alert "Plotmen im Modelbereich nicht zulig.\nWechseln Sie zum Papierbereich!")
          (progn
;         (alert "Plotte Limiten im Papierbereich!")
          (command "_.plot" "_l" "5" "_y" IGM_PLOTTER "_l" "2" PC2-file "_l" "0")
          )
      )
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)



(defun igm_neu_plot ( pc2-file / )
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
      (if (= (getvar "tilemode") 1)
          (alert "Plotmen im Modelbereich nicht zulig.\nWechseln Sie zum Papierbereich!")
          (progn
;         (alert "Plotte Limiten im Papierbereich!")
          (command "_.plot" "_l" "5" "_y" IGM_PLOTTER "_l" "2" PC2-file "_l" "0")
          )
      )
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)

(defun igm_xerox_f_plot ( pc2-file / )
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
      (if (= (getvar "tilemode") 1)
          (alert "Plotmen im Modelbereich nicht zulig.\nWechseln Sie zum Papierbereich!")
          (progn
;         (alert "Plotte Limiten im Papierbereich!")
          (command "_.plot" "_l" "5" "_y" IGM_XEROX_F "_l" "2" PC2-file "_l" "0")
          )
      )
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)

(defun igm_xerox_plot ( pc2-file / )
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
      (if (= (getvar "tilemode") 1)
          (alert "Plotmen im Modelbereich nicht zulig.\nWechseln Sie zum Papierbereich!")
          (progn
;         (alert "Plotte Limiten im Papierbereich!")
          (command "_.plot" "_l" "5" "_y" IGM_XEROX "_l" "2" PC2-file "_l" "0")
          )
      )
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)



(defun igm_neu_druck ( pc2-file / )
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
      (if (= (getvar "tilemode") 1)
          (alert "Plotmen im Modelbereich nicht zulig.\nWechseln Sie zum Papierbereich!")
          (progn
;         (alert "Plotte Limiten im Papierbereich!")
          (command "_.plot" "_l" "5" "_y" IGM_DRUCKER "_l" "2" PC2-file "_l" "0")
          )
      )
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)



(defun igm_neu_lim_druck ( pc2-file limmin limmax / limmin_old limmax_old)
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (setq limmin_old (getvar "limmin")) 
 (setq limmax_old (getvar "limmax")) 


 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setvar "limmin" limmin)
      (setvar "limmax" limmax)
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
      (if (= (getvar "tilemode") 1)
          (alert "Plotmen im Modelbereich nicht zulig.\nWechseln Sie zum Papierbereich!")
          (progn
;          (alert "Plotte Limiten im Papierbereich!")
           (command "_.plot" "_l" "5" "_y" IGM_DRUCKER "_l" "2" PC2-file "_l" "0")
          )
      )
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "limmin" limmin_old)
 (setvar "limmax" limmax_old)


 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)

(defun igm_neu_lim_system_druck ( pc2-file limmin limmax / limmin_old limmax_old)
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (setq limmin_old (getvar "limmin")) 
 (setq limmax_old (getvar "limmax")) 


 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setvar "limmin" limmin)
      (setvar "limmax" limmax)
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
      (if (= (getvar "tilemode") 1)
          (alert "Plotmen im Modelbereich nicht zulig.\nWechseln Sie zum Papierbereich!")
          (progn
;          (alert "Plotte Limiten im Papierbereich!")
           (command "_.plot" "_l" "5" "_y" IGM_SYSTEM_DRUCKER "_l" "2" PC2-file "_l" "0")
          )
      )
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "limmin" limmin_old)
 (setvar "limmax" limmax_old)


 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)


(defun igm_fenster_druck ( pc2-file / igm_fpe1 igm_fpe2)
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (setq igm_fpe1 nil)
 (setq igm_fpe2 nil)

 (while (not igm_fpe1)
  (setq igm_fpe1 (getpoint "\nErste Ecke\t: "))
 ) 
 (while (not igm_fpe2)
  (setq igm_fpe2 (getcorner igm_fpe1 "\nZweite Ecke\t: "))
 )

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
;     (alert "Plotte Fenster")
      (command "_.plot" "_l" "5" "_y" IGM_DRUCKER "_l" "2" PC2-file "_w" igm_fpe1 igm_fpe2 "0")
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (setq *error* olderr)
 (princ)
)


(defun igm_fenster_a3q_druck ( pc2-file / igm_fpe1 igm_fpe2)
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (setq igm_fpe1 nil)
 (setq igm_fpe2 nil)

 (a3q_1-1)
 (while (or (not igm_fpe1)(not igm_fpe2))
  (a3q_1-1)
 ) 

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
;     (alert "Plotte Fenster")
      (command "_.plot" "_l" "5" "_y" IGM_DRUCKER "_l" "2" PC2-file "_w" igm_fpe1 igm_fpe2 "0")
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (redraw)
 (setq *error* olderr)
 (princ)
)

(defun igm_fenster_a3h_druck ( pc2-file / igm_fpe1 igm_fpe2)
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (setq igm_fpe1 nil)
 (setq igm_fpe2 nil)

 (a3h_1-1)
 (while (or (not igm_fpe1)(not igm_fpe2))
  (a3h_1-1)
 ) 

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
;     (alert "Plotte Fenster")
      (command "_.plot" "_l" "5" "_y" IGM_DRUCKER "_l" "2" PC2-file "_w" igm_fpe1 igm_fpe2 "0")
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (redraw)
 (setq *error* olderr)
 (princ)
)


(defun igm_fenster_a4q_druck ( pc2-file / igm_fpe1 igm_fpe2)
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)
 (setq p1 nil p2 nil p3 nil p4 nil)
 (setq igm_fpe1 nil)
 (setq igm_fpe2 nil)

 (a4q_1-1)

 (while (or (not igm_fpe1)(not igm_fpe2))
  (a4q_1-1)
 ) 

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
;     (alert "Plotte Fenster")
      (command "_.plot" "_l" "5" "_y" IGM_DRUCKER "_l" "2" PC2-file "_w" igm_fpe1 igm_fpe2 "0")
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (redraw)
 (setq *error* olderr)
 (princ)
)

(defun igm_fenster_a4h_druck ( pc2-file / igm_fpe1 igm_fpe2)
 (setq *error* myerror)
 (setvar "filedia" 0)
 (setvar "cmddia" 0)

 (a4h_1-1)
 (while (or (not igm_fpe1)(not igm_fpe2))
  (a4h_1-1)
 ) 

 (if (findfile (strcat igm_server_pc2_path pc2-file))
     (progn
      (setq PC2-file (findfile (strcat igm_server_pc2_path pc2-file)))
;     (alert "PC2 Datei gefunden !")
;     (alert "Plotte Fenster A4 HOCH")
      (command "_.plot" "_l" "5" "_y" IGM_DRUCKER "_l" "2" PC2-file "_w" igm_fpe1 igm_fpe2 "0")
     )
     (alert "Kann PC2 Datei nicht finden !")
  )

 (setvar "filedia" 1)
 (setvar "cmddia" 1)
 (redraw)
 (setq *error* olderr)
 (princ)
)


(defun a3h_1-1 ( / lese_punkt punkt code p2 p4 punkt_vorher)
  (while (/= code 3)
  (setq lese_punkt (grread 5))
  (setq code (car lese_punkt))
  (setq punkt (car (cdr lese_punkt)))
  (if (/= punkt_vorher punkt)(redraw))
  (setq p1 (polar punkt (+ 0.0  (atan (/ IGM_A3_B IGM_A3_H))) (/ (sqrt (+ (* IGM_A3_B IGM_A3_B) (* IGM_A3_H IGM_A3_H))) 2)))
  (setq p1 (list (car p1) (cadr p1)))
  (setq p2 (polar punkt (- pi (atan (/ IGM_A3_B IGM_A3_H))) (/ (sqrt (+ (* IGM_A3_B IGM_A3_B) (* IGM_A3_H IGM_A3_H))) 2)))
  (setq p2 (list (car p2) (cadr p2)))
  (setq p3 (polar punkt (+ pi (atan (/ IGM_A3_B IGM_A3_H))) (/ (sqrt (+ (* IGM_A3_B IGM_A3_B) (* IGM_A3_H IGM_A3_H))) 2)))
  (setq p3 (list (car p3) (cadr p3)))
  (setq p4 (polar punkt (- 0  (atan (/ IGM_A3_B IGM_A3_H))) (/ (sqrt (+ (* IGM_A3_B IGM_A3_B) (* IGM_A3_H IGM_A3_H))) 2)))
  (setq p4 (list (car p4) (cadr p4)))
  (draw_temp_rectang)
  (setq punkt_vorher punkt)
  )
 (setq igm_fpe1 p3)
 (setq igm_fpe2 p1)
 (princ)
)

(defun a3q_1-1 ( / lese_punkt punkt code p2 p4 punkt_vorher)
  (while (/= code 3)
  (setq lese_punkt (grread 5))
  (setq code (car lese_punkt))
  (setq punkt (car (cdr lese_punkt)))
  (if (/= punkt_vorher punkt)(redraw))
  (setq p1 (polar punkt (+ 0.0 (atan (/ IGM_A3_H IGM_A3_B))) (/ (sqrt (+ (* IGM_A3_B IGM_A3_B) (* IGM_A3_H IGM_A3_H))) 2)))
  (setq p1 (list (car p1) (cadr p1)))
  (setq p2 (polar punkt (- pi (atan (/ IGM_A3_H IGM_A3_B))) (/ (sqrt (+ (* IGM_A3_B IGM_A3_B) (* IGM_A3_H IGM_A3_H))) 2)))
  (setq p2 (list (car p2) (cadr p2)))
  (setq p3 (polar punkt (+ pi (atan (/ IGM_A3_H IGM_A3_B))) (/ (sqrt (+ (* IGM_A3_B IGM_A3_B) (* IGM_A3_H IGM_A3_H))) 2)))
  (setq p3 (list (car p3) (cadr p3)))
  (setq p4 (polar punkt (- 0  (atan (/ IGM_A3_H IGM_A3_B))) (/ (sqrt (+ (* IGM_A3_B IGM_A3_B) (* IGM_A3_H IGM_A3_H))) 2)))
  (setq p4 (list (car p4) (cadr p4)))
  (draw_temp_rectang)
  (setq punkt_vorher punkt)
  )
 (setq igm_fpe1 p3)
 (setq igm_fpe2 p1)
 (princ)
)


(defun a4h_1-1 ( / lese_punkt punkt code p2 p4 punkt_vorher)
  (setq p2 nil p4 nil)
  (while (/= code 3)
  (setq lese_punkt (grread 5))
  (setq code (car lese_punkt))
  (setq punkt (car (cdr lese_punkt)))
  (if (/= punkt_vorher punkt)(redraw))
  (setq p1 (polar punkt (+ 0.0  (atan (/ IGM_A4_H IGM_A4_B))) (/ (sqrt (+ (* IGM_A4_B IGM_A4_B) (* IGM_A4_H IGM_A4_H))) 2)))
  (setq p1 (list (car p1) (cadr p1)))
  (setq p2 (polar punkt (- pi (atan (/ IGM_A4_H IGM_A4_B))) (/ (sqrt (+ (* IGM_A4_B IGM_A4_B) (* IGM_A4_H IGM_A4_H))) 2)))
  (setq p2 (list (car p2) (cadr p2)))
  (setq p3 (polar punkt (+ pi (atan (/ IGM_A4_H IGM_A4_B))) (/ (sqrt (+ (* IGM_A4_B IGM_A4_B) (* IGM_A4_H IGM_A4_H))) 2)))
  (setq p3 (list (car p3) (cadr p3)))
  (setq p4 (polar punkt (- 0  (atan (/ IGM_A4_H IGM_A4_B))) (/ (sqrt (+ (* IGM_A4_B IGM_A4_B) (* IGM_A4_H IGM_A4_H))) 2)))
  (setq p4 (list (car p4) (cadr p4)))
  (draw_temp_rectang)
  (setq punkt_vorher punkt)
  )
 (setq igm_fpe1 p3)
 (setq igm_fpe2 p1)
 (princ)
)

(defun a4q_1-1 ( / lese_punkt punkt code p2 p4 punkt_vorher)
  (while (/= code 3)
  (setq lese_punkt (grread 5))
  (setq code (car lese_punkt))
  (setq punkt (car (cdr lese_punkt)))
  (if (/= punkt_vorher punkt)(redraw))
  (setq p1 (polar punkt (+ 0.0  (atan (/ IGM_A4_B IGM_A4_H))) (/ (sqrt (+ (* IGM_A4_B IGM_A4_B) (* IGM_A4_H IGM_A4_H))) 2)))
  (setq p1 (list (car p1) (cadr p1)))
  (setq p2 (polar punkt (- pi (atan (/ IGM_A4_B IGM_A4_H))) (/ (sqrt (+ (* IGM_A4_B IGM_A4_B) (* IGM_A4_H IGM_A4_H))) 2)))
  (setq p2 (list (car p2) (cadr p2)))
  (setq p3 (polar punkt (+ pi (atan (/ IGM_A4_B IGM_A4_H))) (/ (sqrt (+ (* IGM_A4_B IGM_A4_B) (* IGM_A4_H IGM_A4_H))) 2)))
  (setq p3 (list (car p3) (cadr p3)))
  (setq p4 (polar punkt (- 0  (atan (/ IGM_A4_B IGM_A4_H))) (/ (sqrt (+ (* IGM_A4_B IGM_A4_B) (* IGM_A4_H IGM_A4_H))) 2)))
  (setq p4 (list (car p4) (cadr p4)))
  (setq punkt_vorher punkt)
  (draw_temp_rectang)
  )
 (setq igm_fpe1 p3)
 (setq igm_fpe2 p1)
 (princ)
)

(defun draw_temp_rectang ()
  (grdraw p1 p2 7)
  (grdraw p2 p3 7)
  (grdraw p3 p4 7)
  (grdraw p4 p1 7)
  (grdraw p2 p4 7)
  (grdraw p1 p3 7)
)

;*****************************************

(defun gen_layer_def ()
 (setq gen_schraff_lay "8")
 (setq gen_schraff_farbe 163)

 (setq gen_rahm2_lay "rahm2")
 (setq gen_rahm2_farbe 253)

 (setq gen_rahm3_lay "rahm3")
 (setq gen_rahm3_farbe 114)

 (setq gen_rahm5_lay "rahm5")
 (setq gen_rahm5_farbe 7)

 (setq gen_1_lay "1")
 (setq gen_1_farbe 6)

 (setq gen_2_lay "2")
 (setq gen_2_farbe 5)

 (setq gen_5_lay "5")
 (setq gen_5_farbe 3)

 (setq gen_6_lay "6")
 (setq gen_6_farbe 2)

 (setq gen_0_lay "0")
 (setq gen_0_farbe 7)

 (setq gen_3_lay "3")
 (setq gen_3_farbe 41)
 (setq gen_3_ltype "gen3")

 (setq gen_7_lay "7")
 (setq gen_7_farbe 1)
 (setq gen_7_ltype "gen7")

 (setq gen_2a_lay "2a")
 (setq gen_2a_farbe 30)
 (setq gen_2a_ltype "GEN7")

)

(defun init ()
 (if (findfile "genius.lin")
     (progn
      (if (not (tblsearch "ltype" "GEN3"))
          (command "_.-linetype" "_l" "gen3" "genius.lin" "")
      )
      (if (not (tblsearch "ltype" "GEN7"))
          (command "_.-linetype" "_l" "gen7" "genius.lin" "")
      )
     )
 )

 (setvar "clayer" "0")
 (setvar "ltscale" 1)
)

(defun gen_layer_def ()
 (gen_layer_only_def)
 (gen_layer_make)
)

(defun gen_layer_make ()
 (command "_.-layer" "_m" gen_schraff_lay "_c" gen_schraff_farbe gen_schraff_lay "")
 (command "_.-layer" "_m" gen_rahm2_lay "_c" gen_rahm2_farbe gen_rahm2_lay "")
 (command "_.-layer" "_m" gen_rahm3_lay "_c" gen_rahm3_farbe gen_rahm3_lay "")
 (command "_.-layer" "_m" gen_rahm5_lay "_c" gen_rahm5_farbe gen_rahm5_lay "")
 (command "_.-layer" "_m" gen_1_lay "_c" gen_1_farbe gen_1_lay "")
 (command "_.-layer" "_m" gen_2_lay "_c" gen_2_farbe gen_2_lay "")
 (command "_.-layer" "_m" gen_5_lay "_c" gen_5_farbe gen_5_lay "")
 (command "_.-layer" "_m" gen_6_lay "_c" gen_6_farbe gen_6_lay "")
 (command "_.-layer" "_m" gen_0_lay "_c" gen_0_farbe gen_0_lay "")
 (command "_.-layer" "_m" gen_3_lay "_l" gen_3_ltype gen_3_lay "_c" gen_3_farbe gen_3_lay "")
 (command "_.-layer" "_m" gen_7_lay "_l" gen_7_ltype gen_7_lay "_c" gen_7_farbe gen_7_lay "")
 (command "_.-layer" "_m" gen_2a_lay "_l" gen_2a_ltype gen_2a_lay "_c" gen_2a_farbe gen_2a_lay "")
)

(defun gen_layer_only_def ()
 (setq gen_schraff_lay "8")
 (setq gen_schraff_farbe 163)

 (setq gen_rahm2_lay "rahm2")
 (setq gen_rahm2_farbe 253)

 (setq gen_rahm3_lay "rahm3")
 (setq gen_rahm3_farbe 114)

 (setq gen_rahm5_lay "rahm5")
 (setq gen_rahm5_farbe 7)

 (setq gen_1_lay "1")
 (setq gen_1_farbe 6)

 (setq gen_2_lay "2")
 (setq gen_2_farbe 5)

 (setq gen_5_lay "5")
 (setq gen_5_farbe 3)

 (setq gen_6_lay "6")
 (setq gen_6_farbe 2)

 (setq gen_0_lay "0")
 (setq gen_0_farbe 7)

 (setq gen_3_lay "3")
 (setq gen_3_farbe 41)
 (setq gen_3_ltype "gen3")

 (setq gen_7_lay "7")
 (setq gen_7_farbe 1)
 (setq gen_7_ltype "gen7")

 (setq gen_2a_lay "2a")
 (setq gen_2a_farbe 30)
 (setq gen_2a_ltype "GEN7")

)


;*********************************************************

(defun func_dimstyle ()
 (setq dimstyle_first (cdr (assoc 2 (tblnext "DIMSTYLE" T))))
 (setq dimstyle_list (list dimstyle_first))
 (while
   (setq dimstyle_next (cdr (assoc 2 (tblnext "DIMSTYLE" ))))
   (setq dimstyle_list (append dimstyle_list (list dimstyle_next)))
 )
 (setq dimstyle_list_length (length dimstyle_list))

 (foreach el_of_list dimstyle_list
  (progn
   (command "_.dim")
   (command "_.restore" el_of_list)
   (func_dim_vars) 
   (command "_.save" el_of_list  "_y")
   (command "_.exit")
  )
 )
 (princ)
)

(defun func_dim_vars ()
 (command "BEMALT" "Aus");       Zustzliche Anzeige von Alternativeinheiten
 (command "BEMALTD"  "4");       Dezimalstellen fr Alternativeinheiten
 (command "BEMALTU" "0.0394");   Umrechnungsfaktor fr Alternativeinheiten
 (command "BEMATDEZ" "4");       Dezimalstellen fr Alternativtoleranz
 (command "BEMATNU" "0");        Nullen unterdrcken bei Alternativtoleranz
 (command "BEMAEINH" "8");       Einheitentyp fr Alternativeinheiten
 (command "BEMAWNU" "0");        Nullen unterdrcken bei Alternativeinheiten 
;(command "BEMANACH" "");        Prfix und Suffix fr Matext von Alternativeinheiten
 (command "BEMASSO" "Ein");      Assoziativ Bemaung generieren
 (command "BEMPLG" "3.5000");    Gre des Malinienkopfes (nur wenn (command "BEMSLG=0)
 (command "BEMWEINH" "0");       Format fr Winkeleinheiten (Typ)
 (command "BEMBLK" "");          Name fr gemeinsamen Pfeilblock
 (command "BEMBLK1" "");         Name fr ersten Pfeilblock
 (command "BEMBLK2" "");         Name fr zweiten Pfeilblock
 (command "BEMZEN" "3.5000");    Gre Zentrumspunkt / Zentrumslinien
 (command "BEMFARM" "3");        Farbe der Ma- und Fhrungslinie
 (command "BEMFARH" "3");        Farbe der Hilfslinie
 (command "BEMFART" "2");        Farbe des Matextes
 (command "BEMDEZ" "4");         Anzahl Dezimalstellen fr Lngenmae
 (command "BEMVML" "0.0000");    Verlngerung der Malinie ber die Hilfslinien
 (command "BEMIML" "5.2500");    Malinien-Abstand bei Basislinien-(command "BEMaungen
 (command "BEMVEH" "1.7500");    Verlngerung der Hilfslinie oberhalb Malinie
 (command "BEMABH"  "0.0");      Abstand der Hilfslinie vom Eingabepunkt
 (command "BEMPASS" "5");        Anordnung von Matext und Pfeilen abhngig vom verfgbaren Platz zwischen den Mahilfslinien
 (command "BEMABST" "1.0000");   Abstand zwischen Text und Malinie
 (command "BEMAUS" "0");         Textausrichtung entlang der Malinie
 (command "BEMGFLA"  "1.0000");  Multiplikator fr die Mazahl bei linearen Einheiten
 (command "BEMGRE" "Aus");       Bemaungsgrenzen generieren
;(command "BEMNACH" "");         Prfix und Suffix fr Matext der Standardmae
 (command "BEMRND" "0.0000");    Rundungswert fr Mazahlen
 (command "BEMPFKT" "Aus");      Getrennte oder gemeinsame Pfeilblcke verwenden
 (command "BEMFKTR" "1.0000");   Skalierfaktor fr die Gre der Bemaungsobjekte
 (command "BEMM1U" "Aus");       Erste Malinie unterdrcken
 (command "BEMM2U" "Aus");       Zweite Malinie unterdrcken
 (command "BEMH1U" "Aus");       Erste Hilfslinie unterdrcken
 (command "BEMH2U" "Aus");       Zweite Hilfslinie unterdrcken
 (command "BEMZUG" "Ein");       Zugmodus fr Bemaungen
 (command "BEMMAHU" "Aus");      Malinie auerhalb Hilfslinie unterdrcken
;(command "BEMSTIL" "ISO-35");   Aktueller Bemaungsstil (schreibgeschtzt)
 (command "BEMTOM" "1");         Text oberhalb der Malinie setzen
 (command "BEMTDEZ" "4");        Anzahl der Dezimalstellen fr Toleranzma bei Standardmaen
 (command "BEMTFAC" "1.0000");   Skalierungsfaktor fr Textgre der Toleranzmae
 (command "BEMTIH" "Aus");       Text innerhalb der Hilfslinien immer horizontal
 (command "BEMTIL" "Aus");       Text immer zwischen den Hilfslinien
;(command "BEMTM" "0.0000");     Minus-Toleranz (Wert wird mit -1 multipliziert)
 (command "BEMTAL" "Ein");       Malinie immer zwischen den Hilfslinien
 (command "BEMTAH" "Aus");       Text auerhalb der Hilfslinien immer horizontal
;(command "BEMTOL" "Aus");       Nennma mit Toleranzen erzeugen
 (command "BEMVAUS" "1");        Vertikale Ausrichtung der Toleranz
;(command "BEMTP" "0.0000");     Plus-Toleranz
 (command "BEMSLG" "0.0000");    Lnge von Schrgstrichen (0 ergibt Mapfeile)
 (command "BEMTVP" "0.0000");    Vertikale Textposition (nur wenn (command "BEMTOM =0)
;(command "BEMTSTIL" "STANDARD");Textstil fr Matexte
 (command "BEMTXT" "3.5000");    Texthhe fr Matexte
 (command "BEMTNZ" "8");         Nullen unterdrcken bei Toleranzmaen
 (command "BEMEINH" "8");        Einheitentyp fr Lngenmae
 (command "BEMBTXT" "Aus");      Vom Benutzer im Zugmodus positionierter Text
 (command "BEMNZ" "8");          Null unterdrcken 
)

;*********************************************************

;Definition der Blcke fr Funktion <igm_alt_block_bereinig>

(setq block_list
 (list "BLOCK-1" "BLOCK-2" "BLOCK-3" "BLOCK-4" "BLOCK-5"
 "FLTOLL" "FLTOLR" "FLTOLS" "FLTOLU" "BEARB" "ACA_CFG"
 "ACA_SAVE_DONT_PURGE" "AME_MAT" "AME_NIL" "AME_SOL"
 "AVE_GLOBAL" "AVE_RENDER" "LAYER" )
)


(defun c:igm_alt_block_bereinig ( / )
;(defun c:igm_alt_block_bereinig ( / dummy_text_height dummy block_list_length block_list)
 (setq auswahl nil)
 (setq dummy_text_height 10.0)
 (setvar "osmode" 0)
 (setvar "attreq" 0)
 (command "_.-layer" "_t" "*" "_on" "*" "")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.25x")
 
 (setq block_list_length (length block_list))
 (setq dummy 0)
 (setq maxpurge 0)

 (while (< dummy block_list_length)
  (while (and (tblsearch "BLOCK" (nth dummy block_list))(< maxpurge 5))
     (progn
      (princ "\nBereinige Block : ")(princ (nth dummy block_list))
      (setq auswahl (ssget "X" (list (cons 0 "INSERT")(cons 2 (nth dummy block_list)))))
      (command "_.erase" auswahl "")
      (command "_.purge" "_al" "*" "_n")
      (setq maxpurge (+ maxpurge 1))
     ) 
  )
  (setq dummy (+ dummy 1))
  (setq maxpurge 0)
 )

 (command "_.zoom" "_e")
 (command "_.purge" "_al" "*" "_n")
 (command "_.purge" "_al" "*" "_n")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.9x")
 (command "_.regen")
 (princ)
)


(defun c:igm_alt_block_bereinig_name  ( / block_list auswahl test_auswahl)
 (setq block_list (getstring "\nWelcher Block : "))
 (setq auswahl nil)
 (setvar "osmode" 0)
 (setvar "attreq" 0)
 (setq test_auswahl (ssget "_w" (getvar "extmin") (getvar "extmax")(list (cons 0 "INSERT")(cons 2 block_list))))

  (if (= test_auswahl nil)
      (progn
       (while (and (tblsearch "BLOCK" block_list) (/= test_auswahl nil))
        (progn
         (princ "\nBereinige Block : ")(princ block_list)(princ "\n")

         (setq auswahl (ssget "X" (list (cons 0 "INSERT")(cons 2 block_list))))
         (command "_.erase" auswahl "")
         (command "_.purge" "_bl" block_list "_n")
         (setq test_auswahl (ssget "_w" (getvar "extmin") (getvar "extmax")(list (cons 0 "INSERT")(cons 2 block_list))))
        ) 
       )
      )
      (alert "Referenzierter Block im Zeichenbereich gefunden")
  )
 (princ)
)

;****************************************
;Konvertierung ME10
(defun c:me10 ()

 (setq *error* myerror)
 (command "_.zoom" "_e")
 (command "_.zoom" "0.8x")
 (command "_.audit" "_y") 
 (command "_.audit" "_y") 
 (init)
 (gen_layer_only_def)

 (setvar "clayer"    "0")
 (setvar "cmdecho"    0)
 (setvar "pickstyle"  1)


 (command "_.purge" "_bl" "*" "_n") 

 (func_me10)
 (func_me10)
 (func_me10)
 (func_me10)
 (func_me10)
 (func_me10)
 (func_me10)
 (func_me10)
 (func_me10)
 (func_me10)
 (func_me10)

 (func_me10_layer)
 (gen_layer_make)
;(func_me10_mittellinie)

 (setq dummy 0)
 (setq auswahl (ssget "X"))
 (setq auswahl_length (sslength auswahl))
 (while (< dummy auswahl_length)
        (setq el (entget (ssname auswahl dummy)))
        (setq el_obj_name (cdr (assoc 0 el)))
        (setq el_block_name (cdr (assoc 2 el)))
        (setq el_lay_name (cdr (assoc 8 el)))
        (setq el_lty_name (cdr (assoc 6 el)))
        (setq el_col_name (cdr (assoc 62 el)))
        (setq el_name (cdr (assoc -1 el)))

        (cond ((= el_lay_name "Mittellinie")
               (command "_.change" el_name "" "_p" "_la" gen_7_lay "")
              ) 
             ((and (= el_obj_name "INSERT")(= (substr el_block_name 1 2) "*X"))
               (command "_.change" el_name "" "_p" "_la" gen_schraff_lay "")
              ) 
             ((= el_lay_name "HATCH")
               (command "_.change" el_name "" "_p" "_la" gen_schraff_lay "")
              ) 
             ((and (= el_obj_name "INSERT")(= (substr el_block_name 1 2) "*d"))
               (command "_.change" el_name "" "_p" "_la" gen_schraff_lay "")
              ) 
             ((= el_lay_name "5")
               (command "_.change" el_name "" "_p" "_la" gen_5_lay "")
              ) 
             ((= el_lay_name "BEMASSUNG")
               (command "_.change" el_name "" "_p" "_la" gen_5_lay "")
              ) 
             ((and (= el_lay_name "VERDECKT")(= el_col_name 2))
               (command "_.change" el_name "" "_p" "_la" gen_3_lay "")
              ) 
             ((= el_lty_name "DASHED")
               (command "_.change" el_name "" "_p" "_la" gen_3_lay "")
              ) 
             ((= el_lty_name "DASHDOT")
               (command "_.change" el_name "" "_p" "_la" gen_7_lay "")
              ) 
             ((= el_lty_name "DOT")
               (command "_.change" el_name "" "_p" "_la" gen_3_lay "")
              ) 
             ((and (= el_col_name 2)(= el_lay_name "VERDECKT"))
               (command "_.change" el_name "" "_p" "_la" gen_3_lay "")
              ) 
;             ((and (= el_col_name 2)(/= el_lay_name "1")(/= el_lay_name "VERDECKT"))
;               (command "_.change" el_name "" "_p" "_la" gen_7_lay "")
;              ) 
             ((and (= el_col_name 2)(= el_lay_name "1"))
               (command "_.change" el_name "" "_p" "_la" gen_5_lay "")
              ) 
             ((and (= el_col_name 3)(= el_lay_name "1"))
               (command "_.change" el_name "" "_p" "_la" gen_0_lay "")
              ) 
             ((and (= el_col_name 4)(= el_obj_name "TEXT"))
               (command "_.change" el_name "" "_p" "_la" gen_6_lay "")
              ) 
             ((and (= el_col_name 4)(/= el_obj_name "TEXT"))
               (command "_.change" el_name "" "_p" "_la" gen_3_lay "")
              ) 
             ((= el_col_name 7)
               (command "_.change" el_name "" "_p" "_la" gen_0_lay "")
              ) 

         ) 
        (setq dummy (+ dummy 1))
        (princ "\rBearbeite Element\t-> ")(princ dummy)(princ " von ")(princ auswahl_length)
  )
 (func_me10_schraffur)
 (func_dimstyle)
;(func_me10_dimension)
 (func_me10_durch_dimstyle)

 (setvar "ltscale" (/ (fix (distance (getvar "extmin")(getvar "extmax"))) 250))
 (command "_.change" "_all" "" "_p" "_co" "_bylayer" "_lty" "_bylayer" "")
 (command "_.style" "standard" "isocp"  "0" "1" "0" "_n" "n")
 (setvar "clayer" "0")
 (command "_.purge" "_al" "*" "_n") 

 (setq *error* olderr)
 (princ)
)


(defun func_me10 ()
 (setq dummy 0)
 (setq auswahl (ssget "X" '((0 . "INSERT"))))
 (setq auswahl_length (sslength auswahl))

 (while (< dummy auswahl_length)
        (setq el (entget (ssname auswahl dummy)))
        (setq el_block_name (cdr (assoc 2 el)))
        (setq el_block (cdr (assoc -1 el)))
        (if (or (= (substr el_block_name 1 2) "*X")(= (substr el_block_name 1 2) "*D"))
            (progn
             (princ)
;            (princ "\nSCHRAFFUR oder BEMASSUNG gefunden")
            )
            (progn
             (princ "\nBlockname : ")
             (princ el_block_name)
             (command "_.explode" el_block)
;            (command "_.purge" "_bl" el_block_name "_n")
             )
        )
        (setq dummy (+ dummy 1))
 )
 (command "_.purge" "_bl" "*" "_n")

)



(defun func_me10_layer ()

 (cond ((and (tblsearch "LAYER" "BEMASSUNG")(= (tblsearch "LAYER" gen_5_lay) nil))
        (command "_.rename" "_la" "BEMASSUNG" gen_5_lay)
        (princ "\nLayer\tBEMASSUNG\t-> ")(princ gen_5_lay)
       )
 )
 (cond ((and (tblsearch "LAYER" "HATCH")(= (tblsearch "LAYER" gen_schraff_lay) nil))
       (command "_.rename" "_la" "HATCH" gen_schraff_lay) 
       (princ "\nLayer\tHATCH\t\t-> ")(princ gen_schraff_lay)
      )
 )
 (cond ((and (tblsearch "LAYER" "MITTELLINIE")(= (tblsearch "LAYER" gen_7_lay) nil))
       (command "_.rename" "_la" "MITTELLINIE" gen_7_lay)
       (princ "\nLayer\tMITTELLINIE\t-> ")(princ gen_7_lay)
      )
 )
 (cond ((and (tblsearch "LAYER" "VERDECKT")(= (tblsearch "LAYER" gen_3_lay) nil))
      (command "_.rename" "_la" "VERDECKT" gen_3_lay)
      (princ "\nLayer\tVERDECKT\t-> ")(princ gen_3_lay)
     )
 )
 (princ "\n")
)

(defun func_me10_mittellinie ()
  (setq auswahl (ssget "X" '((8 . "Mittellinie"))))
  (command "_.change" auswahl "" "_p" "_la" gen_7_lay "")
 (setq auswahl (ssget "X"))
 (setq auswahl_length (sslength auswahl))
 (while (< dummy auswahl_length)
        (setq el (entget (ssname auswahl dummy)))
        (setq el_lay_name (cdr (assoc 8 el)))
        (setq el_lay (cdr (assoc -1 el)))
        (if (= (substr el_lay_name 1 2) "Mittellinie")
            (progn
             (princ)
             (alert "Objekt auf mittellinie gefunden")
            )
        )
        (setq dummy (+ dummy 1))
        (princ "\rBearbeite Element : ")(princ dummy)(princ " von ")(princ auswahl_length)
 )
)



(defun func_me10_schraffur ()
 (setq first_block (tblnext "BLOCK" T))
 (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block))))))

 (if (= (substr (cdr (assoc 2 first_block)) 1 2) "*X")
     (progn
;     (alert"schleife")
;     (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block)))))
      (setq sub_list (entget first_sub_el))
      (setq sub_elem (cdr (assoc -1 (entget first_sub_el))))
      (setq sub_list (entget sub_elem))
      (setq sub_list (subst (cons 62 0)(assoc 62 sub_list) sub_list))
      (entmod sub_list)
;     (princ sub_elem)

      (setq next_sub_elem (entnext sub_elem))
;     (princ next_sub_elem)
      (while next_sub_elem
       (setq next_sub_list (entget next_sub_elem))
       (setq next_sub_list (subst (cons 62 0)(assoc 62 next_sub_list) next_sub_list))
       (entmod next_sub_list)
       (setq next_sub_elem (entnext next_sub_elem))
;      (princ next_sub_elem)
      )
     )
  )

 (while
 (setq first_block (tblnext "BLOCK" ))
 (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block))))))

 (if (= (substr (cdr (assoc 2 first_block)) 1 2) "*X")
     (progn
;     (alert"schleife")
;     (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block)))))
      (setq sub_list (entget first_sub_el))
      (setq sub_elem (cdr (assoc -1 (entget first_sub_el))))
      (setq sub_list (entget sub_elem))
      (setq sub_list (subst (cons 62 0)(assoc 62 sub_list) sub_list))
      (entmod sub_list)
;     (princ sub_elem)

      (setq next_sub_elem (entnext sub_elem))
;     (princ next_sub_elem)
      (while next_sub_elem
       (setq next_sub_list (entget next_sub_elem))
       (setq next_sub_list (subst (cons 62 0)(assoc 62 next_sub_list) next_sub_list))
       (entmod next_sub_list)
       (setq next_sub_elem (entnext next_sub_elem))
;      (princ next_sub_elem)
      )
     )
  )
 )
 (command "_.regen")
 (princ)
)

(defun func_me10_dimension ()
 (setq first_block (tblnext "BLOCK" T))
 (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block))))))

 (if (= (substr (cdr (assoc 2 first_block)) 1 2) "*D")
     (progn
;     (alert"schleife")
;     (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block)))))
      (setq sub_list (entget first_sub_el))
      (setq sub_elem (cdr (assoc -1 (entget first_sub_el))))
      (setq sub_list (entget sub_elem))
      (setq sub_obj (cdr (assoc 0 sub_list)))
      (if (= sub_obj "TEXT")
          (progn
           (setq sub_list (subst (cons 62 2)(assoc 62 sub_list) sub_list))
           (entmod sub_list)
          )
          (progn
           (setq sub_list (subst (cons 62 0)(assoc 62 sub_list) sub_list))
           (entmod sub_list)
          )
      )
;     (princ sub_elem)

      (setq next_sub_elem (entnext sub_elem))
;     (princ next_sub_elem)
      (while next_sub_elem
       (setq next_sub_list (entget next_sub_elem))
       (setq next_sub_obj (cdr (assoc 0 next_sub_list)))
       (if (= sub_obj "TEXT")
           (progn
            (setq next_sub_list (subst (cons 62 2)(assoc 62 next_sub_list) next_sub_list))
            (entmod next_sub_list)
           )
           (progn
            (setq next_sub_list (subst (cons 62 0)(assoc 62 next_sub_list) next_sub_list))
            (entmod next_sub_list)
           )
       )
       (setq next_sub_elem (entnext next_sub_elem))
;      (princ next_sub_elem)
      )
     )
  )

 (while
 (setq first_block (tblnext "BLOCK"))
 (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block))))))

 (if (= (substr (cdr (assoc 2 first_block)) 1 2) "*D")
     (progn
;     (alert"schleife")
;     (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block)))))
      (setq sub_list (entget first_sub_el))
      (setq sub_elem (cdr (assoc -1 (entget first_sub_el))))
      (setq sub_list (entget sub_elem))
      (setq sub_obj (cdr (assoc 0 sub_list)))
      (if (= sub_obj "TEXT")
          (progn
           (setq sub_list (subst (cons 62 2)(assoc 62 sub_list) sub_list))
           (entmod sub_list)
          )
          (progn
           (setq sub_list (subst (cons 62 0)(assoc 62 sub_list) sub_list))
           (entmod sub_list)
          )
      )
;     (princ sub_elem)

      (setq next_sub_elem (entnext sub_elem))
;     (princ next_sub_elem)
      (while next_sub_elem
       (setq next_sub_list (entget next_sub_elem))
       (setq next_sub_obj (cdr (assoc 0 next_sub_list)))
       (if (= next_sub_obj "TEXT")
           (progn
            (setq next_sub_list (subst (cons 62 2)(assoc 62 next_sub_list) next_sub_list))
            (entmod next_sub_list)
           )
           (progn
            (setq next_sub_list (subst (cons 62 0)(assoc 62 next_sub_list) next_sub_list))
            (entmod next_sub_list)
           )
       )
       (setq next_sub_elem (entnext next_sub_elem))
;      (princ next_sub_elem)
      )
     )
  )
 )
 (command "_.regen")
 (princ)
)

(defun func_dimstyle ()
 (setq dimstyle_first (cdr (assoc 2 (tblnext "DIMSTYLE" T))))
 (setq dimstyle_list (list dimstyle_first))
 (while
   (setq dimstyle_next (cdr (assoc 2 (tblnext "DIMSTYLE" ))))
   (setq dimstyle_list (append dimstyle_list (list dimstyle_next)))
 )
 (setq dimstyle_list_length (length dimstyle_list))

 (foreach el_of_list dimstyle_list
  (progn
   (command "_.dim")
   (command "_.restore" el_of_list)
   (func_dim_vars) 
   (command "_.save" el_of_list  "_y")
   (command "_.exit")
  )
 )

 (command "_.dim")
 (func_dim_vars) 
 (func_gen_dim_vars) 
 (command "_.save" "GENISO")
 (command "_.exit")

 (princ)
)


(defun func_dim_vars ()
 (command "BEMALT" "Aus");       Zustzliche Anzeige von Alternativeinheiten
 (command "BEMALTD"  "4");       Dezimalstellen fr Alternativeinheiten
 (command "BEMALTU" "0.0394");   Umrechnungsfaktor fr Alternativeinheiten
 (command "BEMATDEZ" "4");       Dezimalstellen fr Alternativtoleranz
 (command "BEMATNU" "0");        Nullen unterdrcken bei Alternativtoleranz
 (command "BEMAEINH" "8");       Einheitentyp fr Alternativeinheiten
 (command "BEMAWNU" "0");        Nullen unterdrcken bei Alternativeinheiten 
;(command "BEMANACH" " ");        Prfix und Suffix fr Matext von Alternativeinheiten
 (command "BEMASSO" "Ein");      Assoziativ Bemaung generieren
 (command "BEMPLG" "3.5000");    Gre des Malinienkopfes (nur wenn (command "BEMSLG=0)
 (command "BEMWEINH" "0");       Format fr Winkeleinheiten (Typ)
 (command "BEMBLK" " ");          Name fr gemeinsamen Pfeilblock
 (command "BEMBLK1" " ");         Name fr ersten Pfeilblock
 (command "BEMBLK2" " ");         Name fr zweiten Pfeilblock
 (command "BEMZEN" "3.5000");    Gre Zentrumspunkt / Zentrumslinien
 (command "BEMFARM" "3");        Farbe der Ma- und Fhrungslinie
 (command "BEMFARH" "3");        Farbe der Hilfslinie
 (command "BEMFART" "2");        Farbe des Matextes
 (command "BEMDEZ" "4");         Anzahl Dezimalstellen fr Lngenmae
 (command "BEMVML" "0.0000");    Verlngerung der Malinie ber die Hilfslinien
 (command "BEMIML" "5.2500");    Malinien-Abstand bei Basislinien-(command "BEMaungen
 (command "BEMVEH" "1.7500");    Verlngerung der Hilfslinie oberhalb Malinie
 (command "BEMABH"  "0.0");      Abstand der Hilfslinie vom Eingabepunkt
 (command "BEMPASS" "2");        Anordnung von Matext und Pfeilen abhngig vom verfgbaren Platz zwischen den Mahilfslinien
 (command "BEMABST" "1.0000");   Abstand zwischen Text und Malinie
 (command "BEMAUS" "0");         Textausrichtung entlang der Malinie
 (command "BEMGFLA"  "1.0000");  Multiplikator fr die Mazahl bei linearen Einheiten
 (command "BEMGRE" "Aus");       Bemaungsgrenzen generieren
;(command "BEMNACH" "");         Prfix und Suffix fr Matext der Standardmae
 (command "BEMRND" "0.0000");    Rundungswert fr Mazahlen
 (command "BEMPFKT" "Aus");      Getrennte oder gemeinsame Pfeilblcke verwenden
 (command "BEMFKTR" "1.0000");   Skalierfaktor fr die Gre der Bemaungsobjekte
 (command "BEMM1U" "Aus");       Erste Malinie unterdrcken
 (command "BEMM2U" "Aus");       Zweite Malinie unterdrcken
 (command "BEMH1U" "Aus");       Erste Hilfslinie unterdrcken
 (command "BEMH2U" "Aus");       Zweite Hilfslinie unterdrcken
 (command "BEMZUG" "Ein");       Zugmodus fr Bemaungen
 (command "BEMMAHU" "Aus");      Malinie auerhalb Hilfslinie unterdrcken
;(command "BEMSTIL" "ISO-35");   Aktueller Bemaungsstil (schreibgeschtzt)
 (command "BEMTOM" "1");         Text oberhalb der Malinie setzen
 (command "BEMTDEZ" "4");        Anzahl der Dezimalstellen fr Toleranzma bei Standardmaen
 (command "BEMTFAC" "1.0000");   Skalierungsfaktor fr Textgre der Toleranzmae
 (command "BEMTIH" "Aus");       Text innerhalb der Hilfslinien immer horizontal
 (command "BEMTIL" "Aus");       Text immer zwischen den Hilfslinien
;(command "BEMTM" "0.0000");     Minus-Toleranz (Wert wird mit -1 multipliziert)
 (command "BEMTAL" "Ein");       Malinie immer zwischen den Hilfslinien
 (command "BEMTAH" "Aus");       Text auerhalb der Hilfslinien immer horizontal
;(command "BEMTOL" "Aus");       Nennma mit Toleranzen erzeugen
 (command "BEMVAUS" "1");        Vertikale Ausrichtung der Toleranz
;(command "BEMTP" "0.0000");     Plus-Toleranz
 (command "BEMSLG" "0.0000");    Lnge von Schrgstrichen (0 ergibt Mapfeile)
 (command "BEMTVP" "0.0000");    Vertikale Textposition (nur wenn (command "BEMTOM =0)
;(command "BEMTSTIL" "STANDARD");Textstil fr Matexte
 (command "BEMTXT" "3.5000");    Texthhe fr Matexte
 (command "BEMTNZ" "8");         Nullen unterdrcken bei Toleranzmaen
 (command "BEMEINH" "8");        Einheitentyp fr Lngenmae
 (command "BEMBTXT" "Aus");      Vom Benutzer im Zugmodus positionierter Text
 (command "BEMNZ" "8");          Null unterdrcken 
)

(defun func_gen_dim_vars ()
 (command "BEMANACH" " ");       Prfix und Suffix fr Matext von Alternativeinheiten
 (command "BEMNACH" " ");        Prfix und Suffix fr Matext der Standardmae
 (command "BEMTM" "0.0000");     Minus-Toleranz (Wert wird mit -1 multipliziert)
 (command "BEMTOL" "Aus");       Nennma mit Toleranzen erzeugen
 (command "BEMTP" "0.0000");     Plus-Toleranz
 (command "BEMPASS" "3");        Anordnung von Matext und Pfeilen abhngig vom verfgbaren Platz zwischen den Mahilfslinien
)




(defun func_me10_durch_dimstyle ()
 (setq auswahl (ssget "X" '((0 . "DIMENSION"))))
 (setq auswahl_length (sslength auswahl))
 (setq dummy 0)
 (while (< dummy auswahl_length)
        (setq el (ssname auswahl dummy))
        (setq el_list (entget (ssname auswahl dummy)))
        (setq bemtext (cdr (assoc 1 (entget el))))
        (cond ((= (substr bemtext 1 1) "")
               (setq bemtext (substr bemtext 2))
               (setq bemtext (strcat "%%c" bemtext))
               (setq el_list (subst (cons 1 bemtext)(assoc 1 el_list) el_list))
               (entmod el_list)
              )
             ((= (substr bemtext 3 1) "")
               (setq bemtext_v (substr bemtext 1 2))
               (setq bemtext_n (substr bemtext 4))
               (setq bemtext (strcat bemtext_v "%%c" bemtext_n))
               (setq el_list (subst (cons 1 bemtext)(assoc 1 el_list) el_list))
               (entmod el_list)
              )

        )
        (setq dummy (+ dummy 1))
 )
 (princ)
)


;****************************************
;Konvertierung EUKLID

(defun c:euklid ()
 (setvar "cmdecho" 0)
 (setq *error* myerror)
 (setq view_name (cdr (assoc 2 (tblnext "VIEW" T))))
 (if (/= view_name nil)
 (progn
 (init)
 (gen_layer_def)

 (setvar "clayer"    "0")
 (setvar "cmdecho"    0)
 (setvar "pickstyle"  1)

 (setq dummy 0)

;(princ view_name)
 (setq view_list (list view_name)) 

 (while
  (setq view_name (cdr (assoc 2 (tblnext "VIEW"))))
; (princ "\nName der Ansicht : ")
; (princ view_name)
  (setq view_list (append view_list (list view_name)))
 )

 (setq view_list_length (length view_list)) 

;(alert "Alle Ansichtsfenster werden nun gelscht!")


; (command "_.vplayer" "_t" "*" "_al" "")

 (setq auswahl (ssget "X" '((0 . "VIEWPORT"))))
 (command "_.erase" auswahl "")


  (setvar "tilemode"   1)

  (command "_.-layer" "_t" "*" "_on" "*" "")
  (command "_.ucs" "_w")
  (command "_.plan" "_w")


 (command "_.vpoint" "_non" "*1,-1,1")

;(initget 7)
;(setq faktor (getdist "\nFaktor : "))
 (setq faktor (/ (distance (getvar "extmin")(getvar "extmax")) 100)) 

 (while (< dummy view_list_length)

  (command "_.view" "_r" (nth dummy view_list))
  (command "_.ucs" "_view")
; (command "_.vpoint" "_non" "*1,-1,1")
  (setq auswahl (ssget "X" (list (cons 8 (strcat "0_" (nth dummy view_list))))))
  (if (/= auswahl nil)
      (progn
       (command "_.cutclip" auswahl "")
       (command "_.ucs" "_w")
       (command "_.plan" "_w")
       (princ "\nBearbeite Ansicht :\t")(princ (nth dummy view_list))
;      (princ auswahl)
       (setq px 0)
       (setq py (* dummy (* dummy faktor)))
       (command "_.pasteclip" (list px py) "1" "1" "0")
       (command "_.zoom" "_e")
       (command "_.zoom" "0.5x")
       (command "_.explode" "_l")
       (command "_.-group" "_c" "*" "" "_p" "")
      )
;     (alert "Keine geeigneten Objekte gefunden ! ")
  )
  (setq dummy (+ dummy 1))
 )

  (command "_.zoom" "_e")
  (command "_.zoom" "0.8x")

 (princ "\n")


 (command "_.-layer" "_fr" gen_5_lay "")  
 (setq auswahl (ssget "X" '((0 . "DIMENSION"))))
 (if auswahl
     (progn
      (setq auswahl_length (sslength auswahl))
      (setq dummy 0)
      (while (< dummy auswahl_length)
             (setq el_dim (entget (ssname auswahl dummy)))
             (setq el_dim (subst (cons 8 gen_5_lay)(assoc 8 el_dim) el_dim))
             (entmod el_dim)
             (setq dummy (+ dummy 1))
      )
     )
 )
  (euklid_gen_lay)

  (command "_.zoom" "_e")
  (command "_.zoom" "0.8x")
  (command "_.purge" "_al" "*" "_n")
  (command "_.purge" "_al" "*" "_n")
  (command "_.purge" "_al" "*" "_n")
  (command "_.purge" "_al" "*" "_n")
  (setvar "pickstyle" 1)
 )
 (progn
  (alert "ACHTUNG: Keine Ansichten vorhanden -> Keine Euklid Zeichnung")
 )
 )


(setq *error* olderr)
(princ)
)


(defun euklid_gen_lay ()
 (setvar "pickstyle" 0)
 (command "_.zoom" "_e")
 (command "_.zoom" "0.8x")

 (setq auswahl (ssget "X"))

 (setq auswahl_length (sslength auswahl))
 (setq dummy 0)
 (while (< dummy auswahl_length)
         (setq el (entget (ssname auswahl dummy)))
         (setq el_color (cdr (assoc 62 el)))
         (setq el_ltype (cdr (assoc 6 el)))
         (Princ "\rBearbeite Element :\t")(princ dummy)(princ " von ")(princ auswahl_length)
         (if (/= el_color nil)
         (progn
         (cond ((= el_color 3)
                (setq el (subst (cons 8 gen_1_lay)(assoc 8 el) el))
                (entmod el)
;               (command "_.change" (cdr (assoc -1 el)) "" "_p" "_co" "_bylayer" "")
               )  
               ((= el_ltype "CENTER")
;               (alert "Mittellinie")
                (setq el (subst (cons 8 gen_7_lay)(assoc 8 el) el))
                (setq el (subst (cons 62 gen_7_farbe)(assoc 62 el) el))
                (setq el (subst (cons 6 gen_7_ltype)(assoc 6 el) el))
                (entmod el)
;               (command "_.change" (cdr (assoc -1 el)) "" "_p" "_co" "_bylayer" "")
               )  
               ((= el_ltype "DOT")
;               (alert "Verdeckt")
                (setq el (subst (cons 8 gen_3_lay)(assoc 8 el) el))
                (setq el (subst (cons 62 gen_3_farbe)(assoc 62 el) el))
                (setq el (subst (cons 6 gen_3_ltype)(assoc 6 el) el))
                (entmod el)
;               (command "_.change" (cdr (assoc -1 el)) "" "_p" "_co" "_bylayer" "")
               )  
               ((= el_color 2)
                (setq el (subst (cons 8 gen_0_lay)(assoc 8 el) el))
                (entmod el)
;               (command "_.change" (cdr (assoc -1 el)) "" "_p" "_co" "_bylayer" "")
               )  
               ((= el_color 7)
                (setq el (subst (cons 8 gen_6_lay)(assoc 8 el) el))
                (entmod el)
;               (command "_.change" (cdr (assoc -1 el)) "" "_p" "_co" "_bylayer" "")
               )  
               ((= el_color 4)
                (setq el (subst (cons 8 gen_6_lay)(assoc 8 el) el))
                (entmod el)
;               (command "_.change" (cdr (assoc -1 el)) "" "_p" "_co" "_bylayer" "")
               )  

               ((and (= el_color 5) (/= el_type "DOT"))
                (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
                (entmod el)
;               (command "_.change" (cdr (assoc -1 el)) "" "_p" "_co" "_bylayer" "")
               )  

               ((= el_color 6)
                (setq el (subst (cons 8 gen_2_lay)(assoc 8 el) el))
                (entmod el)
;               (command "_.change" (cdr (assoc -1 el)) "" "_p" "_co" "_bylayer" "")
               )  


         )
         )
         )
         (setq dummy (+ dummy 1))
  )
 (command "_.-layer" "_fr" gen_5_lay "")  
 (setq auswahl (ssget "X" '((0 . "DIMENSION"))))


 (if auswahl
     (progn
      (setq auswahl_length (sslength auswahl))
      (setq dummy 0)
      (while (< dummy auswahl_length)
             (setq el_dim (entget (ssname auswahl dummy)))
             (setq el_dim (subst (cons 8 gen_5_lay)(assoc 8 el_dim) el_dim))
             (entmod el_dim)
             (setq dummy (+ dummy 1))
      )
     )
 )


 (setq dummy 0)
 (setvar "clayer" "0")
 (while (< dummy view_list_length)
  (setq auswahl (ssget "X" (list (cons 8 (strcat "0_" (nth dummy view_list))))))
  (if (/= auswahl nil)
      (progn
       (command "_.erase" auswahl "")
      )
;     (alert "Keine geeigneten Objekte gefunden ! ")
  )
  (setq dummy (+ dummy 1))
 )
 (command "_.zoom" "_e")
 (command "_.zoom" "0.5x")
 (command "_.change" "_all" "" "_p" "_co" "_bylayer" "")
 (command "_.ltscale" "20")
 (command "_.regen")
(princ)
)



;****************************************
;Konvertierung VACZI

(defun c:vaczi ( / auswahl)
 (setq *error* myerror)
 (setvar "cmdecho" 0)

 (command "_.-layer" "_t" "*" "_on" "*" "")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.8x")
 (command "_.insert" "dummy" "0,0" "1" "1" "0")

 (func_explode_all_block)
 (func_explode_all_block)
 (func_explode_all_block)
 (func_explode_all_block)

 (schraffur2)
 (schraffur1)
 (schraffur3)
 
 (setq auswahl (ssget "X" '((0 . "INSERT")(2 . "DUMMY"))))
 (command "_.erase" auswahl "")
 (command "_.purge" "_al" "*" "_n")
 (setvar "insname" ".")

 (convert_old_layer)
 (convert_old_layer)

 (command "_.change" "_all" "" "_p" "_co" "_bylayer" "_lty" "_bylayer" "")
 (setq *error* olderr)
 (princ)
)

(defun func_explode_all_block ()
 (princ "\nBearbeite Blcke...\n")

 (setq gen_schraff_lay "8")
 (setq gen_schraff_farbe 163)
 (if (not (tblsearch "LAYER" gen_schraff_lay))
     (command "_.-layer" "_n" gen_schraff_lay "_c" gen_schraff_farbe gen_schraff_lay "")
 )
 (setq dummy 0)
 (setq auswahl (ssget "X" '((0 . "INSERT"))))
 (if auswahl (setq auswahl_length (sslength auswahl)))
 (while (< dummy auswahl_length)
        (setq el (entget (ssname auswahl dummy)))
        (setq el_block_name (cdr (assoc 2 el)))
        (setq el_block (cdr (assoc -1 el)))
        (setq el_hoch  (cdr (assoc 210 el)))

;       (if (or (= (substr el_block_name 1 2) "*X")(= (substr el_block_name 1 2) "*D"))
        (if (= (substr el_block_name 1 2) "*D")
            (progn
              (princ)
            )
            (progn
;             (princ "\rBlockname : ")
;             (princ el_block_name)
             (if (or (= el_block_name "SKOPF")
                     (= el_block_name "KOPF")
                     (= el_block_name "KOPF_VER")
                     (= el_block_name "MAKO")
                     (= el_block_name "RKOPF")
                     (= el_block_name "DUMMY")
                  )
                 (princ)
                 (command "_.explode" el_block)
             )
            )
        )
        (setq dummy (+ dummy 1))
 )
 (command "_.purge" "_bl" "*" "_n")
 (setq auswahl nil auswahl_length nil dummy nil)
)




(defun schraffur1 ()
 (princ "\nBearbeite Schraffuren...\n")
 (setq gen_schraff_lay "8")
 (setq gen_schraff_farbe 163)
 (if (not (tblsearch "LAYER" gen_schraff_lay))
     (command "_.-layer" "_n" gen_schraff_lay "_c" gen_schraff_farbe gen_schraff_lay "")
 )
 (setq dummy 0)
 (setq auswahl (ssget "X" '((0 . "INSERT"))))
 (if auswahl (setq auswahl_length (sslength auswahl)))
 (while (< dummy auswahl_length)
        (setq el (entget (ssname auswahl dummy)))
        (setq el_block_name (cdr (assoc 2 el)))
        (setq el_block (cdr (assoc -1 el)))

        (if (= (substr el_block_name 1 2) "*X")
            (progn
             (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
             (entmod el)
            )
        )
        (setq dummy (+ dummy 1))
 )
 (setq auswahl nil auswahl_length nil dummy nil)
)

(defun schraffur3 ()
 (princ "\nBearbeite Schraffuren...\n")

 (setq gen_schraff_lay "8")
 (setq gen_schraff_farbe 163)
 (if (not (tblsearch "LAYER" gen_schraff_lay))
     (command "_.-layer" "_n" gen_schraff_lay "_c" gen_schraff_farbe gen_schraff_lay "")
 )

 (setq dummy 0)
 (setq auswahl (ssget "X"))
 (if auswahl (setq auswahl_length (sslength auswahl)))
 (while (< dummy auswahl_length)
        (setq el (entget (ssname auswahl dummy)))
        (if (and (= (cdr (assoc 0 el)) "LINE") (= (cdr (assoc 8 el)) "25C"))
            (progn 
             (setq w (angle (cdr (assoc 10 el)) (cdr (assoc 11 el))))
             (cond
              ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
            )
           )
        )

        (if (and (=  (cdr (assoc 0 el)) "LINE")
                 (/= (cdr (assoc 8 el)) "35C")
                 (/= (cdr (assoc 8 el)) "35G")
                 (/= (cdr (assoc 8 el)) "25M")
                 (/= (cdr (assoc 8 el)) "50C")
                 (/= (cdr (assoc 8 el)) "25C")
                 (=  (cdr (assoc 62 el)) 2)
            )
            (progn 
             (setq w (angle (cdr (assoc 10 el)) (cdr (assoc 11 el))))
             (cond
              ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
            )
           )
        )



       (if (and (= (cdr (assoc 0 el)) "LINE") (= (cdr (assoc 8 el)) "0"))
            (progn 
             (setq w (angle (cdr (assoc 10 el)) (cdr (assoc 11 el))))
             (cond
              ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
            )
           )
        )


        (if (and (=  (cdr (assoc 0 el)) "LINE")
                 (/= (cdr (assoc 8 el)) "35C")
                 (/= (cdr (assoc 8 el)) "35G")
                 (/= (cdr (assoc 8 el)) "25M")
                 (/= (cdr (assoc 8 el)) "50C")
                 (/= (cdr (assoc 8 el)) "25C")
                 (=  (cdr (assoc 62 el)) 2)
            )
            (progn 
             (setq w (angle (cdr (assoc 10 el)) (cdr (assoc 11 el))))
             (cond
              ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
              ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
               (setq el (subst (cons 8 gen_schraff_lay)(assoc 8 el) el))
               (entmod el)
              )
            )
           )
        )


       (setq dummy (+ dummy 1))
  )
  (setq auswahl nil auswahl_length nil dummy nil)
)



(defun schraffur2 ()

 (setq gen_schraff_lay "8")
 (setq gen_schraff_farbe 163)
 (if (not (tblsearch "LAYER" gen_schraff_lay))
     (command "_.-layer" "_n" gen_schraff_lay "_c" gen_schraff_farbe gen_schraff_lay "")
 )
 (setq first_block (tblnext "BLOCK" T))
 (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block))))))

 (if (= (substr (cdr (assoc 2 first_block)) 1 2) "*X")
     (progn
      (setq sub_list (entget first_sub_el))
      (setq sub_elem (cdr (assoc -1 (entget first_sub_el))))
      (setq sub_list (entget sub_elem))

      (setq sub_list (subst (cons 62 gen_schraff_farbe)(assoc 62 sub_list) sub_list))
      (setq sub_list (subst (cons 8 gen_schraff_lay)(assoc 8 sub_list) sub_list))
      (entmod sub_list)

      (setq next_sub_elem (entnext sub_elem))
      (while next_sub_elem
       (setq next_sub_list (entget next_sub_elem))

       (setq next_sub_list (subst (cons 62 gen_schraff_farbe)(assoc 62 next_sub_list) next_sub_list))
       (setq next_sub_list (subst (cons 8 gen_schraff_lay)(assoc 8 next_sub_list) next_sub_list))
       (entmod next_sub_list)

       (setq next_sub_elem (entnext next_sub_elem))
      )
     )
  )
 (while
 (setq first_block (tblnext "BLOCK" ))
 (setq first_sub_el (cdr (assoc -1 (entget (cdr (assoc -2 first_block))))))
 (if (= (substr (cdr (assoc 2 first_block)) 1 2) "*X")
     (progn
;     (alert "Schraffur")
      (setq sub_list (entget first_sub_el))
      (setq sub_elem (cdr (assoc -1 (entget first_sub_el))))

      (setq sub_list (subst (cons 62 gen_schraff_farbe)(assoc 62 sub_list) sub_list))
      (setq sub_list (subst (cons 8 gen_schraff_lay)(assoc 8 sub_list) sub_list))
      (entmod sub_list)

      (setq next_sub_elem (entnext sub_elem))
      (while next_sub_elem

       (setq next_sub_list (subst (cons 62 gen_schraff_farbe)(assoc 62 next_sub_list) next_sub_list))
       (setq next_sub_list (subst (cons 8 gen_schraff_lay)(assoc 8 next_sub_list) next_sub_list))
       (entmod next_sub_list)

       (entmod next_sub_list)
       (setq next_sub_elem (entnext next_sub_elem))
      )
     )
  )
 )
)




(defun convert_old_layer ()
 (princ "\nBearbeite alte Layer...\n")
 (init)
 (gen_layer_def) 
 (setq dummy 0)
 (setq auswahl (ssget "X"))
 (if auswahl (setq auswahl_length (sslength auswahl)))
 (while (< dummy auswahl_length)
        (setq el (entget (ssname auswahl dummy)))
        (cond
         ((= (cdr (assoc 8 el)) "50C")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_0_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((and (= (cdr (assoc 8 el)) "L1")(/= (cdr (assoc 62 el)) 3)(= (cdr (assoc 62 el)) 2))
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_rahm2_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((and (= (cdr (assoc 8 el)) "L1")(= (cdr (assoc 62 el)) 3)(/= (cdr (assoc 62 el)) 2))
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_rahm5_lay)(assoc 8 el) el))
          (entmod el)
         ) 

         ((= (cdr (assoc 8 el)) "35G")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_3_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "35C")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_1_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "25G")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_3_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "25C")
;          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_1_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "25M")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_7_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "70M")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_2a_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "70C")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_2_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "BEMA")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_5_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "BEMASSUNG")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_5_lay)(assoc 8 el) el))
          (entmod el)
         ) 

         ((= (cdr (assoc 8 el)) "U2STAR")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_1_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "M2STAR")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_7_lay)(assoc 8 el) el))
          (entmod el)
         ) 
         ((= (cdr (assoc 8 el)) "L5STAR")
          (setq el (subst (cons 62 256)(assoc 62 el) el))
          (setq el (subst (cons 8 gen_0_lay)(assoc 8 el) el))
          (entmod el)
         ) 

        )
       (setq dummy (+ dummy 1))
 )

 (command "_.purge" "_la" "*" "_n") 
 (command "_.purge" "_al" "*" "_n") 

 (setvar "clayer" "0")
)

;*************************************************
;;Konvertierung Massblatt

(defun c:massblatt ()
 (setq auswahl nil)
 (setq dummy 10.0)
 (command "_.purge" "_al" "*" "_n")
 (command "_.purge" "_al" "*" "_n")
 (setvar "osmode" 0)
 (setvar "attreq" 0)
 (command "_.-layer" "_t" "*" "_on" "*" "")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.25x")
 (if (tblsearch "BLOCK" "MAKO")
     (progn
      (command "_.insert" "mako=" "0,0" "1" "1" "0")
      (command "_.purge" "_al" "*" "_n")
      (command "_.erase" "_l" "")
     )
 )

 (if (tblsearch "BLOCK" "FEJ2")
     (progn
      (command "_.insert" "FEJ2=" "0,0" "1" "1" "0")
      (command "_.purge" "_al" "*" "_n")
      (command "_.erase" "_l" "")
     )
 )

 (if (tblsearch "BLOCK" "KOPF_MB")
     (progn
      (command "_.insert" "kopf_mb=" "0,0" "1" "1" "0")
      (command "_.purge" "_al" "*" "_n")
      (command "_.erase" "_l" "")
     )
 )
 (if (tblsearch "BLOCK" "RKOPF")
     (progn
      (command "_.insert" "RKOPF=" "0,0" "1" "1" "0")
      (command "_.purge" "_al" "*" "_n")
      (command "_.erase" "_l" "")
     )
 )
 (if (tblsearch "BLOCK" "SKOPF")
     (progn
      (command "_.insert" "SKOPF=" "0,0" "1" "1" "0")
      (command "_.purge" "_al" "*" "_n")
      (command "_.erase" "_l" "")
     )
 )
 (if (tblsearch "BLOCK" "KOPF_VER")
     (progn
      (command "_.insert" "KOPF_VER=" "0,0" "1" "1" "0")
      (command "_.purge" "_al" "*" "_n")
      (command "_.erase" "_l" "")
     )
 )

 (if (tblsearch "BLOCK" "1M")
     (progn
      (command "_.insert" "1M" "0,0" "1" "1" "0")
      (command "_.purge" "_al" "*" "_n")
      (command "_.erase" "_l" "")
     )
 )

 (while (tblsearch "BLOCK" "BLOCK-1")
     (progn
      (command "_.text" "0,0" dummy "0" "BLOCK-1")
      (command "_.block" "BLOCK-1" "_y" "0,0" "_l" "")
      (command "_.zoom" "_e")
      (setq auswahl (ssget "X" (list (cons 0 "INSERT")(cons 2 "BLOCK-1"))))
      (command "_.erase" auswahl "")
      (command "_.purge" "_bl" "BLOCK-1" "_n")
     ) 
 )

 (while (tblsearch "BLOCK" "BLOCK-2")
     (progn
      (command "_.text" "0,0" dummy "0" "BLOCK-2")
      (command "_.block" "BLOCK-2" "_y" "0,0" "_l" "")
      (command "_.zoom" "_e")
      (setq auswahl (ssget "X" (list (cons 0 "INSERT")(cons 2 "BLOCK-2"))))
      (command "_.erase" auswahl "")
      (command "_.purge" "_al" "*" "_n")
     ) 
 )


 (while (tblsearch "BLOCK" "BLOCK-3")
     (progn
      (command "_.text" "0,0" dummy "0" "BLOCK-3")
      (command "_.block" "BLOCK-3" "_y" "0,0" "_l" "")
      (command "_.zoom" "_e")
      (setq auswahl (ssget "X" (list (cons 0 "INSERT")(cons 2 "BLOCK-3"))))
      (command "_.erase" auswahl "")
      (command "_.purge" "_al" "*" "_n")
     ) 
 )
 (while (tblsearch "BLOCK" "BLOCK-4")
     (progn
      (command "_.text" "0,0" dummy "0" "BLOCK-4")
      (command "_.block" "BLOCK-4" "_y" "0,0" "_l" "")
      (command "_.zoom" "_e")
      (setq auswahl (ssget "X" (list (cons 0 "INSERT")(cons 2 "BLOCK-4"))))
      (command "_.erase" auswahl "")
      (command "_.purge" "_al" "*" "_n")
     ) 
 )
 (while (tblsearch "BLOCK" "BLOCK-5")
     (progn
      (command "_.text" "0,0" dummy "0" "BLOCK-5")
      (command "_.block" "BLOCK-5" "_y" "0,0" "_l" "")
      (command "_.zoom" "_e")
      (setq auswahl (ssget "X" (list (cons 0 "INSERT")(cons 2 "BLOCK-5"))))
      (command "_.erase" auswahl "")
      (command "_.purge" "_al" "*" "_n")
     ) 
 )


 (command "_.zoom" "_e")
 (func_r1)
 (twattskal_mb 0.9)
 (command "_.style" "standard" "isocp.shx" "0" "1" "0" "n" "n")
 (command "_.purge" "_al" "*" "_n")
 (command "_.purge" "_al" "*" "_n")
 (command "_.zoom" "_e")
 (command "_.zoom" "0.9x")
 (command "_.limmin" (getvar "extmin"))
 (command "_.limmax" (getvar "extmax"))
 (setvar "ltscale" (fix (/ (distance (getvar "extmin")(getvar "extmax")) 500)))
 (command "_.regen")
 (princ)
)

;**************************
;R1

(defun c:r1 ( / e nr al bn w a)
 (setq *error* myerror)
 (setvar "cmdecho" 0)
 (bereinigen)
 (init)
 (gen_layer_def)

 (command "_.convert" "s" "al")

 (command "_.select" "_all" "")
 (setq a (ssget "_p"))
 (setq al (sslength a))
 (setq nr 0)
 (command "_.change" a "" "_p" "_co" "_bylayer" "_lt" "_bylayer" "")
 (while (< nr al)
  (setq e (ssname a nr))
  (setq ee (entget e))

  (if (and (= (cdr (assoc 0 ee)) "LINE") (= (cdr (assoc 8 ee)) "25C")(not (< (cadddr (assoc 210 ee)) 0)))
      (progn 
	(setq w (angle (cdr (assoc 10 ee)) (cdr (assoc 11 ee))))
	(cond
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "")
	  )
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "")
	  )
	)
      )
      (if (and (= (cdr (assoc 0 ee)) "INSERT")(= (substr (cdr (assoc 2 ee)) 1 2) "*X")(not (< (cadddr (assoc 210 ee)) 0)))
          (progn 
;           (alert "Schraffur gefunden")
            (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
          )
      )
  )


  (if (and (= (cdr (assoc 0 ee)) "LINE") (= (cdr (assoc 8 ee)) "SCHRAFFUR")(not (< (cadddr (assoc 210 ee)) 0)))
      (progn 
	(setq w (angle (cdr (assoc 10 ee)) (cdr (assoc 11 ee))))
	(cond
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	)
      )
  )

 (if (and (= (cdr (assoc 0 ee)) "LINE") (= (cdr (assoc 62 ee)) 2)(not (< (cadddr (assoc 210 ee)) 0)))
      (progn 
;	(princ "\nElement ")(princ nr)(princ " Schraffurhnliche Linie gefunden")
	(setq w (angle (cdr (assoc 10 ee)) (cdr (assoc 11 ee))))
	(setq winkel (/ (* w 180) pi))
	(cond
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	)
      )
  )



  (setq nr (+ nr 1))
  (princ "\rBearbeite Element ")(princ nr)(princ " von ")(princ al)(princ "              ")
)
  (princ "\nSuche nach Schraffuren in Blcken...")
 (igm_schraff_in_block)
 (r2)
 (igm_25C_in_block)
 (bereinigen)
 (bemup)
 (setvar "clayer" "0")

 (setq *error* olderr)
 (princ)
)

(defun igm_schraff_in_block ( / auswahl o_name e_name e_schraff e_lin) 

 (setq auswahl (ssget "X" '((0 . "HATCH"))))
 (if (= auswahl nil)
     (princ)
     (command "_.change" auswahl "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
 )

 (setq e (tblnext "BLOCK" T))
 (if (= e nil)
     (princ "\nKeine Blcke in der Zeichnung vorhanden")
     (progn
 	(while
	    (progn
	     (setq e (cdr (assoc -2 e)))
	     (while e
	      (setq e_name (cdr (assoc -1 (entget e))))  ;Name des 1. Elementes im Block
	      (setq o_name (cdr (assoc  0 (entget e))))  ;Name des 1. ees im Block
	      (if (= o_name "INSERT")
	          (progn
	           (setq e_schraff (entget e_name))
	           (setq e_schraff (subst (cons 8 gen_schraff_lay) (assoc 8 e_schraff) e_schraff))
	           (entmod e_schraff)
	          )
	      )
	      (if (and (= o_name "INSERT")(not (= (substr (cdr (assoc  0 (entget e))) 1 2) "*X")))
	          (progn
	           (setq e_schraff (entget e_name))
	           (setq e_schraff (subst (cons 8 gen_0_lay) (assoc 8 e_schraff) e_schraff))
	           (entmod e_schraff)
	          )
	      )
	      (if (= o_name "HATCH")
	          (progn
	           (setq e_schraff (entget e_name))
	           (setq e_schraff (subst (cons 8 gen_schraff_lay) (assoc 8 e_schraff) e_schraff))
	           (entmod e_schraff)
	          )
	      )
	      (if (= o_name "LINE")
	          (progn
                   (setq e_lin (entget e_name))
                   (if (= (cdr (assoc 8 e_lin)) "25C")
                       (progn
;                       (princ "\nSchraffurhnliche linie gefunden")
			(setq e (cdr (assoc -1 e_lin)))
                   	(setq w (angle (cdr (assoc 10 e_lin)) (cdr (assoc 11 e_lin)))) 
			(cond
			  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
			      (setq e_lin (subst (cons 8 gen_schraff_lay) (assoc 8 e_lin) e_lin))
			      (entmod e_lin)
	  			      (setq e_lin (subst (cons 62 gen_schraff_farbe) (assoc 62 e_lin) e_lin))
				      (entmod e_lin)
			  )
			  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
			      (setq e_lin (subst (cons 8 gen_schraff_lay) (assoc 8 e_lin) e_lin))
			      (entmod e_lin)
	  			      (setq e_lin (subst (cons 62 gen_schraff_farbe) (assoc 62 e_lin) e_lin))
				      (entmod e_lin)

			  )
			  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
			      (setq e_lin (subst (cons 8 gen_schraff_lay) (assoc 8 e_lin) e_lin))
			      (entmod e_lin)
	  			      (setq e_lin (subst (cons 62 gen_schraff_farbe) (assoc 62 e_lin) e_lin))
				      (entmod e_lin)
			  )
			  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
			      (setq e_lin (subst (cons 8 gen_schraff_lay) (assoc 8 e_lin) e_lin))
			      (entmod e_lin)
	  			      (setq e_lin (subst (cons 62 gen_schraff_farbe) (assoc 62 e_lin) e_lin))
				      (entmod e_lin)

			  )
                        )
                       ) 
                  ) 
                  )
              )
	      (setq e (entnext e_name))
	     )
	     (setq e (tblnext "BLOCK"))
	    )
	 )
     )
 )
)


(defun r2 ( / e nr al bn w a gen_schraff_lay gen_schraff_farbe)

 (command "_.select" "_all" "")
 (setq a (ssget "_p"))
 (setq al (sslength a))
 (setq nr 0)
 (while (< nr al)
;(while (< nr 402)
  (setq e (ssname a nr))
  (setq ee (entget e))

 (if (and (= (cdr (assoc 0 ee)) "INSERT")
	   (not (= (substr (cdr (assoc 2 ee)) 1 2) "*X"))
	   (not (< (cadddr (assoc 210 ee)) 0))
      )
      (progn 
;      (princ "\nBlockname : ")(princ (cdr (assoc 2 ee)))
       (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_0_lay "_lt" "_bylayer" "")
      )
  )


 (if (and (= (cdr (assoc 8 ee)) "25C")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <25C> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_1_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "U2STAR")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <USTAR2> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_1_lay "_lt" "_bylayer" "")
      )
  )


 (if (and (= (cdr (assoc 8 ee)) "BEMA")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <Bema> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_5_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "BEMASSUNG")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <Bemassung> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_5_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "25M")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <25M> gefunden                    ")
       (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_7_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "25G")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <25g> gefunden                    ")
       (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_3_lay "_lt" "_bylayer" "")
      )
  )



 (if (and (= (cdr (assoc 8 ee)) "MITTE")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <MITTE> gefunden                    ")
       (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_7_lay "_lt" "_bylayer" "")
      )
  )


 (if (and (= (cdr (assoc 8 ee)) "50C")(= (cdr (assoc 62 ee)) 3)(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <50C> gefunden                     ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_rahm5_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "50C")(= (cdr (assoc 62 ee)) 2)(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <50C> gefunden                     ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_rahm2_lay "_lt" "_bylayer" "")
      )
  )


 (if (and (= (cdr (assoc 8 ee)) "50C")(not (= (cdr (assoc 62 ee)) 3))(not (= (cdr (assoc 62 ee)) 2))(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <50C> gefunden                     ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_0_lay "_lt" "_bylayer" "")
      )
  )



 (if (and (= (cdr (assoc 8 ee)) "35C")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <35C> gefunden                     ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_1_lay "_lt" "_bylayer" "")
      )
  )


 (if (and (= (cdr (assoc 8 ee)) "35G")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <35G> gefunden                     ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_3_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "25U")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <25U> gefunden                     ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_3_lay "_lt" "_bylayer" "")
      )
  )


 (if (and (= (cdr (assoc 8 ee)) "70M")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <70M> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_2a_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "70C")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <70C> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_2_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "L1")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <L1C> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_0_lay "_lt" "_bylayer" "")
      )
  )


 (if (and (= (cdr (assoc 8 ee)) "RAHM2")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <RAHM2> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_RAHM2_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "RAHM3")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <RAHM3> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_RAHM3_lay "_lt" "_bylayer" "")
      )
  )

 (if (and (= (cdr (assoc 8 ee)) "RAHM5")(not (< (cadddr (assoc 210 ee)) 0))(/= (cdr (assoc 0 ee)) "INSERT"))
      (progn 
;       (princ "\tObjekte auf Layer <RAHM5> gefunden                    ")
        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
       (command "_.change" e "" "_p" "_la" gen_RAHM5_lay "_lt" "_bylayer" "")
      )
  )


  (setq nr (+ nr 1))
  (princ "\rBearbeite Element ")(princ nr)(princ " von ")(princ al)(princ "              ")
)
  (princ "\nSuche nach Layern in Blcken...")
  (princ)
)


(defun igm_25C_in_block ( / auswahl o_name e_name  e_lin) 

 (setq e (tblnext "BLOCK" T))
 (if (= e nil)
     (princ "\nKeine Blcke in der Zeichnung vorhanden")
     (progn
 	(while
	    (progn
	     (setq e (cdr (assoc -2 e)))
	     (while e
	      (setq e_name (cdr (assoc -1 (entget e))))  ;Name des 1. Elementes im Block
	      (setq o_name (cdr (assoc  0 (entget e))))  ;Name des 1. des im Block
              (objekte_in_block)
	      (setq e (entnext e_name))
	     )
	     (setq e (tblnext "BLOCK"))
	    )
	 )
     )
)
(command "_.regen")
(princ)
)



(defun bereinigen ()
 (command "_.purge" "_al" "*" "_n")
 (command "_.purge" "_al" "*" "_n")
 (command "_.purge" "_al" "*" "_n")
 (command "_.purge" "_al" "*" "_n")
 (command "_.purge" "_al" "*" "_n")
)


(defun objekte_in_block ()
 	      (if (or (= o_name "LINE")(= o_name "POLYLINE")(= o_name "ARC")(= o_name "CIRCLE")(= o_name "TEXT")
		      (= o_name "CIRCLE")(= o_name "ATTDEF"))
	          (progn
                   (setq e_lin (entget e_name))
                   (if (= (cdr (assoc 8 e_lin)) "25C")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_1_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_1_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
                   (if (= (cdr (assoc 8 e_lin)) "35C")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_1_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_1_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
 
                   (if (= (cdr (assoc 8 e_lin)) "BEMA")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_5_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_5_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
                   (if (= (cdr (assoc 8 e_lin)) "BEMASSUNG")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_5_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_5_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
                   (if (= (cdr (assoc 8 e_lin)) "25M")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_7_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_7_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
                   (if (= (cdr (assoc 8 e_lin)) "50C")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_0_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_0_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
                   (if (= (cdr (assoc 8 e_lin)) "70M")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_2a_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_2a_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 

                   (if (= (cdr (assoc 8 e_lin)) "70C")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_2_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_2_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 

                   (if (= (cdr (assoc 8 e_lin)) "35G")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_3_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_3_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
                   (if (= (cdr (assoc 8 e_lin)) "RAHM2")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_RAHM2_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_RAHM2_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 

                   (if (= (cdr (assoc 8 e_lin)) "RAHM3")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_RAHM3_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_RAHM3_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
                   (if (= (cdr (assoc 8 e_lin)) "RAHM3")
                       (progn
 		        (setq e_lin (subst (cons 8 gen_RAHM3_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_RAHM3_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
                       ) 
                  ) 
                 );end progn
               ); end if
 	      (if (= o_name "ATTRIB")
	          (progn
                   (setq e_lin (entget e_name))
;                   (if (= (cdr (assoc 8 e_lin)) "50C")
                       (progn
			(alert "ATTRIB")
 		        (setq e_lin (subst (cons 8 gen_0_lay) (assoc 8 e_lin) e_lin))
			(entmod e_lin)
  			(setq e_lin (subst (cons 62 gen_0_farbe) (assoc 62 e_lin) e_lin))
			(entmod e_lin)
			(setq e_lin eef)
;                        (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
;                        (command "_.change" e "" "_p" "_la" gen_rahm5_lay "_lt" "_bylayer" "")
                       ) 
;                  ) 
                 )
              )
)


(defun c:GEN_LAY_OFF ()
 (alert "Bitte kontolieren Sie ob noch alte Layer sichtbar sind.\nAlle GENIUS Layer sind ausgeblendet.")
 (command "_.-layer" "_off" gen_schraff_lay "")
 (command "_.-layer" "_off" gen_0_lay "")
 (command "_.-layer" "_off" gen_1_lay "")
 (command "_.-layer" "_off" gen_2_lay "")
 (command "_.-layer" "_off" gen_2a_lay "")
 (command "_.-layer" "_off" gen_3_lay "")
 (command "_.-layer" "_off" gen_5_lay "")
 (command "_.-layer" "_off" gen_7_lay "")
 (command "_.-layer" "_off" gen_rahm2_lay "")
 (command "_.-layer" "_off" gen_rahm3_lay "")
 (command "_.-layer" "_off" gen_rahm5_lay "")
)


(defun bemup ()
 (setq dimstyle_old (getvar "dimstyle"))
 (setvar "dimgap" 0.875)
 (setvar "DIMCLRD" 3)
 (setvar "DIMCLRE" 3)
 (setvar "DIMCLRT" 2)
 (setvar "DIMASZ" 3.5)
 (command "_.dim1" "_save" dimstyle_old "_y")
 (command "_.dim1" "_update" "_all" "")
 (princ)
)


(princ)

(defun func_r1 ( / e nr al bn w a)
 (setvar "cmdecho" 0)
 (bereinigen)
 (init)
 (gen_layer_def)

 (command "_.convert" "s" "al")

 (command "_.select" "_all" "")
 (setq a (ssget "_p"))
 (setq al (sslength a))
 (setq nr 0)
 (command "_.change" a "" "_p" "_co" "_bylayer" "_lt" "_bylayer" "")
 (while (< nr al)
  (setq e (ssname a nr))
  (setq ee (entget e))

  (if (and (= (cdr (assoc 0 ee)) "LINE") (= (cdr (assoc 8 ee)) "25C")(not (< (cadddr (assoc 210 ee)) 0)))
      (progn 
	(setq w (angle (cdr (assoc 10 ee)) (cdr (assoc 11 ee))))
	(cond
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "")
	  )
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "")
	  )
	)
      )
      (if (and (= (cdr (assoc 0 ee)) "INSERT")(= (substr (cdr (assoc 2 ee)) 1 2) "*X")(not (< (cadddr (assoc 210 ee)) 0)))
          (progn 
;           (alert "Schraffur gefunden")
            (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
          )
      )
  )


  (if (and (= (cdr (assoc 0 ee)) "LINE") (= (cdr (assoc 8 ee)) "SCHRAFFUR")(not (< (cadddr (assoc 210 ee)) 0)))
      (progn 
	(setq w (angle (cdr (assoc 10 ee)) (cdr (assoc 11 ee))))
	(cond
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	)
      )
  )

 (if (and (= (cdr (assoc 0 ee)) "LINE") (= (cdr (assoc 62 ee)) 2)(not (< (cadddr (assoc 210 ee)) 0)))
      (progn 
;	(princ "\nElement ")(princ nr)(princ " Schraffurhnliche Linie gefunden")
	(setq w (angle (cdr (assoc 10 ee)) (cdr (assoc 11 ee))))
	(setq winkel (/ (* w 180) pi))
	(cond
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ 0 (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 1))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	  ((= (rtos w) (rtos (+ pi (* (/ pi 4) 3))))
              (command "_.change" e "" "_p" "_c" "_bylayer" "_lt" "_bylayer" "")
	      (command "_.change" e "" "_p" "_la" gen_schraff_lay "_lt" "_bylayer" "")
	  )
	)
      )
  )



  (setq nr (+ nr 1))
  (princ "\rBearbeite Element ")(princ nr)(princ " von ")(princ al)(princ "              ")
)
  (princ "\nSuche nach Schraffuren in Blcken...")
 (igm_schraff_in_block)
 (r2)
 (igm_25C_in_block)
 (bereinigen)
 (bemup)
 (setvar "clayer" "0")
 (princ)
)


;Konvertierung ende
;*********************************************************

(defun c:alt_kopf_update ( / antw)
 (alert "Bei alten DOS-Zeichnungen mu die Datenbasis (Umlaute: , , ,...) schon vorher umgestellt sein!\nBefehl: Datenbasis DOS auf WIN.")
 (initget "j n")
 (setq antw (getkword "\nWeiter j/<n> : "))
 (if (= antw "j")
     (progn
      (setvar "attreq" 0) 
      (setq blockname (cdr (assoc 2 (tblnext "Block" T))))
      (kopf_update)
      (while
       (setq blockname (cdr (assoc 2 (tblnext "Block"))))
       (kopf_update)
     )
    )
 )     
 (princ)
)


(defun kopf_update ()
  (cond ((= blockname "SKOPF")
        (alert "Schriftkopf gefunden: SKOPF")
        (command "_.insert" "skopf=" "0,0" 1 1 0)
        (command "_.erase" "_l" "")
       )
       ((= blockname "RKOPF")
        (alert "Schriftkopf gefunden: RKOPF")
        (command "_.insert" "rkopf=" "0,0" 1 1 0)
        (command "_.erase" "_l" "")
       )
       ((= blockname "KOPF_VER")
        (alert "Schriftkopf gefunden: KOPF_VER")
        (command "_.insert" "KOPF_VER=" "0,0" 1 1 0)
        (command "_.erase" "_l" "")
       )
       ((= blockname "MAKO")
        (alert "Schriftkopf gefunden: MAKO")
        (command "_.insert" "MAKO=" "0,0" 1 1 0)
        (command "_.erase" "_l" "")
       )
       ((= blockname "FEJ2")
        (alert "Schriftkopf gefunden: FEJ2")
        (command "_.insert" "FEJ2=" "0,0" 1 1 0)
        (command "_.erase" "_l" "")
       )
       ((= blockname "KOPF")
        (alert "Schriftkopf gefunden: KOPF")
        (command "_.insert" "KOPF=" "0,0" 1 1 0)
        (command "_.erase" "_l" "")
       )
 )
)
